// DlgBridges.cpp : implementation file
//

#include "stdafx.h"
#include "Classes.h"
#include "PowerDesigner2.h"
#include "DlgBridges.h"


// CDlgBridges dialog

IMPLEMENT_DYNAMIC(CDlgBridges, CDialog)
CDlgBridges::CDlgBridges(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBridges::IDD, pParent)
{
}

CDlgBridges::~CDlgBridges()
{
}

void CDlgBridges::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LS_PASSAGES, m_e_Bridges);
}


BEGIN_MESSAGE_MAP(CDlgBridges, CDialog)
	ON_LBN_SELCHANGE(IDC_LS_PASSAGES, OnLbnSelchangeLsPassages)
END_MESSAGE_MAP()


// CDlgBridges message handlers
int CDlgBridges::DoModal(tag_t *Splines_i, CEdge *Edges_i, int iEdgesNum_i)
{
	Splines = Splines_i;
	Edges = Edges_i;
	iEdgesNum = iEdgesNum_i;

	return CDialog::DoModal();
}

BOOL CDlgBridges::OnInitDialog()
{
	CDialog::OnInitDialog();

CString string;

	// 
	for(int i=0;i<iEdgesNum-1;i++)
	{
		string.Format(" %d", i);
		if(Edges[i].bNothing || Edges[i+1].bNothing)
			m_e_Bridges.SetItemData(m_e_Bridges.AddString(string), i);
	}
	if(Edges[iEdgesNum-1].bNothing || Edges[0].bNothing)
	{
		string.Format(" %d", i);
		m_e_Bridges.SetItemData(m_e_Bridges.AddString(string), iEdgesNum-1);
	}

	DrawBridges();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgBridges::UGRefresh()
{
CRect Rect;

	GetWindowRect(&Rect);
	SetWindowPos(NULL, Rect.left, Rect.top%2 ? Rect.top+1 : Rect.top-1, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
}

void CDlgBridges::DrawBridges()
{
tag_t Curves[2], Bridge;
double dParms[2]={1,0}, dPoint[3]={0,0,0}, dTolerance[2]={.01,0};
int iReverse[2]={0,0}, iOne=1;
UF_CURVE_line_s Coords;
UF_CURVE_trim_s Trim;
UF_STRING_t TrimCurve, String;
UF_CURVE_trim_to_u TrimTo;
UF_CURVE_trim_bound_s TrimBound;
UF_CURVE_trim_mult_s TrimOut;
//UF_CURVE_intersect_info_s Intersection;

	TrimCurve.num = 1;
	TrimCurve.string = &iOne;
	TrimCurve.dir = &iOne;

	String.num = 0;
	String.dir = &iOne;

//	for(int i=0;i<iEdgesNum-1;i++)
	for(int i=0;i<1;i++)
	{
		if(Edges[i].bNothing || Edges[i+1].bNothing)
			switch(Edges[i].iBridgeType)
			{
			//
			case 0:
				Curves[0] = Splines[i];
				Curves[1] = Splines[i+1];
				UF_CALL(UF_CURVE_create_bridge_curve(UF_CURVE_TANGENT, Curves, dParms, iReverse, &Bridge));
				break;
			//
			case 1:
				UF_CALL(UF_CURVE_evaluate_curve(Splines[i], 1, UF_CURVE_LOC, Coords.start_point));
				UF_CALL(UF_CURVE_evaluate_curve(Splines[i+1], 0, UF_CURVE_LOC, Coords.end_point));
				UF_CALL(UF_CURVE_create_line(&Coords, &Bridge));
				break;
			///
			case 2:
				TrimBound.string = String;
				TrimBound.object = Splines[i+1];
				TrimBound.use_suggested = FALSE;

				TrimTo.one_bound.string_trim_extend_end = UF_CURVE_TRIM_EXTEND_END;
				TrimTo.one_bound.bound = TrimBound;
				TrimTo.one_bound.trim_bound = TRUE;
				TrimTo.one_bound.view = NULL;

				TrimCurve.id = &Splines[i];

				Trim.string_to_trim = TrimCurve;
				Trim.spline_extend_opt = UF_CURVE_EXTEND_NATURAL;
				Trim.trim_type = UF_CURVE_TRIM_TO_ONE_BOUND;
				Trim.tolerances[0] = .1;
				Trim.tolerances[1] = .5;
				Trim.trim_to = TrimTo;
				UF_CALL(UF_CURVE_create_trim(&Trim, &TrimOut, &Bridge));
//				UF_CALL(UF_CURVE_intersect(Splines[i], Splines[i+1], dPoint, &Intersection));
//				// 
//				if(Intersection.type_of_intersection != 0)
//				{
//				}
				break;
			}
	}

	if(Edges[iEdgesNum-1].bNothing || Edges[0].bNothing)
	{
//		m_e_Bridges.SetItemData(m_e_Bridges.AddString(string), iEdgesNum-1);
	}
}

void CDlgBridges::OnLbnSelchangeLsPassages()
{
	// 
//	for(int i=0;i<m_e_Edges.GetCount();i++)
//		if(i==m_e_Edges.GetCurSel())
		{
		}

}
