// DlgCustomSections.cpp : implementation file
//

#include "stdafx.h"
#include "Classes.h"
#include "PowerDesigner2.h"
#include "DlgCustomSections.h"


bool FindNumber(CDWordArray *Array, int iNumber)
{
	for(int i=0;i<Array->GetCount();i++)
		if(Array->GetAt(i) == iNumber)
			return true;
	return false;
}

// CDlgCustomSections dialog

IMPLEMENT_DYNAMIC(CDlgCustomSections, CDialog)
CDlgCustomSections::CDlgCustomSections(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCustomSections::IDD, pParent)
{
	bInitialized = false;
}

CDlgCustomSections::~CDlgCustomSections()
{
}

void CDlgCustomSections::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LS_EDGES, m_c_Edges);
	DDX_Control(pDX, IDC_LS_SECTIONS, m_c_Sections);
}


BEGIN_MESSAGE_MAP(CDlgCustomSections, CDialog)
	ON_BN_CLICKED(IDC_BUT_ADD_SECTION, OnBnClickedButAddSection)
	ON_LBN_SELCHANGE(IDC_LS_EDGES, OnLbnSelchangeLsEdges)
	ON_BN_CLICKED(IDC_BUT_UP, OnBnClickedButUp)
	ON_BN_CLICKED(IDC_BUT_DOWN, OnBnClickedButDown)
	ON_LBN_SELCHANGE(IDC_LS_SECTIONS, OnLbnSelchangeLsSections)
	ON_BN_CLICKED(IDC_BUT_DEL_SECTION, OnBnClickedButDelSection)
//	ON_BN_CLICKED(IDOK, OnBnClickedOk)
//	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CDlgCustomSections message handlers

INT_PTR CDlgCustomSections::DoModal(CEdge *Edges_i, int iEdgesNum_i)
{
	Edges = Edges_i;
	iEdgesNum = iEdgesNum_i;

	CustomSections = new CDWordArray[iEdgesNum_i];

	return CDialog::DoModal();
}

BOOL CDlgCustomSections::OnInitDialog()
{
	CDialog::OnInitDialog();

CString string;

	// 
	for(int i=0;i<iEdgesNum;i++)
	{
		string.Format(" %d", i);
		if(!Edges[i].bNothing && !Edges[i].bPS)
			m_c_Edges.SetItemData(m_c_Edges.AddString(string), i);
	}

	bInitialized = true;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgCustomSections::OnBnClickedButAddSection()
{
	if(m_c_Edges.GetCurSel()==LB_ERR)
		return;

	//,   
	int iSelEdge = m_c_Edges.GetItemData(m_c_Edges.GetCurSel());

	double dPoint[3], dTangent[3];
	// 
	int iNewSection = 1;
//	while(FindNumber(&CustomSections[iSelEdge], iNewSection) && iNewSection<CustomSections[iSelEdge].GetCount()-1)
	while(FindNumber(&CustomSections[iSelEdge], iNewSection))
		iNewSection++;
	//     
	if(iNewSection<Edges[iSelEdge].iSectionsNum-1)
	{
		CustomSections[iSelEdge].Add(iNewSection);
		m_c_Sections.AddString("");

		Edges[iSelEdge].Sections[iNewSection].PointRealBase.Fill(dPoint);
		Edges[iSelEdge].Sections[iNewSection].PlaneSectionNormal.Fill(dTangent);
		UF_CALL(UF_MODL_create_plane(
			dPoint,
			dTangent,
			&Edges[iSelEdge].Sections[iNewSection].PlaneSection));

		//    
		UF_CALL(UF_OBJ_set_color(Edges[iSelEdge].Sections[iNewSection].PlaneSection, UF_OBJ_YELLOW));

		UGRefresh();
	}
}

void CDlgCustomSections::OnBnClickedButDelSection()
{
	if(m_c_Edges.GetCurSel()==LB_ERR || m_c_Sections.GetCurSel()==LB_ERR)
		return;

	//,     
	int iSelEdge = m_c_Edges.GetItemData(m_c_Edges.GetCurSel());
	int iSelSection = m_c_Sections.GetCurSel();

	//  
	UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[CustomSections[iSelEdge][iSelSection]].PlaneSection));

	//   
	CustomSections[iSelEdge].RemoveAt(iSelSection);

	//   
	m_c_Sections.DeleteString(iSelSection);
}

void CDlgCustomSections::OnLbnSelchangeLsEdges()
{
double dPoint[3], dTangent[3];

	//
	if(m_c_Sections.GetCount())
		while(m_c_Sections.DeleteString(0));

	//    
	for(int k=0;k<m_c_Edges.GetCount();k++)
	{
		int iSelEdge = m_c_Edges.GetItemData(k);

		// 
		//
		if(UF_OBJ_ask_status(Edges[iSelEdge].Sections[0].PlaneSection) == UF_OBJ_ALIVE)
			UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[0].PlaneSection));
		//
		if(UF_OBJ_ask_status(Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PlaneSection) == UF_OBJ_ALIVE)
			UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PlaneSection));
		// 
		for(int i=0;i<CustomSections[iSelEdge].GetCount();i++)
			if(UF_OBJ_ask_status(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection) == UF_OBJ_ALIVE)
				UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection));
	}

	if(m_c_Edges.GetCurSel()==LB_ERR)
		return;

	//,   
	int iSelEdge = m_c_Edges.GetItemData(m_c_Edges.GetCurSel());

	//   
	for(int i=0;i<CustomSections[iSelEdge].GetCount();i++)
		m_c_Sections.AddString("");

	//   
	//
	Edges[iSelEdge].Sections[0].PointRealBase.Fill(dPoint);
	Edges[iSelEdge].Sections[0].PlaneSectionNormal.Fill(dTangent);
	UF_CALL(UF_MODL_create_plane(
		dPoint,
		dTangent,
		&Edges[iSelEdge].Sections[0].PlaneSection));
	//
	Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PointRealBase.Fill(dPoint);
	Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PlaneSectionNormal.Fill(dTangent);
	UF_CALL(UF_MODL_create_plane(
		dPoint,
		dTangent,
		&Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PlaneSection));
	// 
	for(int i=0;i<CustomSections[iSelEdge].GetCount();i++)
	{
		Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PointRealBase.Fill(dPoint);
		Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSectionNormal.Fill(dTangent);
		UF_CALL(UF_MODL_create_plane(
			dPoint,
			dTangent,
			&Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection));

		//    
		UF_CALL(UF_OBJ_set_color(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection, UF_OBJ_YELLOW));
	}

	UGRefresh();
}

void CDlgCustomSections::OnBnClickedButDown()
{
	if(m_c_Edges.GetCurSel()==LB_ERR || m_c_Sections.GetCurSel()==LB_ERR)
		return;

	double dPoint[3], dTangent[3];

	//,     
	int iSelEdge = m_c_Edges.GetItemData(m_c_Edges.GetCurSel());
	int iSelSection = m_c_Sections.GetCurSel();

	int iNewPlace = CustomSections[iSelEdge][iSelSection];

	while(FindNumber(&CustomSections[iSelEdge], iNewPlace))
		iNewPlace++;

	//     
	if(iNewPlace<Edges[iSelEdge].iSectionsNum-1)
	{
		//  
		UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[CustomSections[iSelEdge][iSelSection]].PlaneSection));

		CustomSections[iSelEdge][iSelSection] = iNewPlace;

		//  
		Edges[iSelEdge].Sections[iNewPlace].PointRealBase.Fill(dPoint);
		Edges[iSelEdge].Sections[iNewPlace].PlaneSectionNormal.Fill(dTangent);
		UF_CALL(UF_MODL_create_plane(
			dPoint,
			dTangent,
			&Edges[iSelEdge].Sections[iNewPlace].PlaneSection));

		//    
		UF_CALL(UF_OBJ_set_color(Edges[iSelEdge].Sections[iNewPlace].PlaneSection, UF_OBJ_RED));

		//   ,    
		CustomSections[iSelEdge].RemoveAt(iSelSection);
		int iTemp = 0;
		while(iTemp<CustomSections[iSelEdge].GetCount() && CustomSections[iSelEdge][iTemp] < iNewPlace)
			iTemp++;
		CustomSections[iSelEdge].InsertAt(iTemp, iNewPlace);

		//   
		m_c_Sections.SetCurSel(iTemp);

		UGRefresh();
	}
}

void CDlgCustomSections::OnBnClickedButUp()
{
	if(m_c_Edges.GetCurSel()==LB_ERR || m_c_Sections.GetCurSel()==LB_ERR)
		return;

	double dPoint[3], dTangent[3];

	//,     
	int iSelEdge = m_c_Edges.GetItemData(m_c_Edges.GetCurSel());
	int iSelSection = m_c_Sections.GetCurSel();

	int iNewPlace = CustomSections[iSelEdge][iSelSection];

	while(FindNumber(&CustomSections[iSelEdge], iNewPlace))
		iNewPlace--;

	//     
	if(iNewPlace>0)
	{
		//  
		UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[CustomSections[iSelEdge][iSelSection]].PlaneSection));

		CustomSections[iSelEdge][iSelSection] = iNewPlace;

		//  
		Edges[iSelEdge].Sections[iNewPlace].PointRealBase.Fill(dPoint);
		Edges[iSelEdge].Sections[iNewPlace].PlaneSectionNormal.Fill(dTangent);
		UF_CALL(UF_MODL_create_plane(
			dPoint,
			dTangent,
			&Edges[iSelEdge].Sections[iNewPlace].PlaneSection));

		//    
		UF_CALL(UF_OBJ_set_color(Edges[iSelEdge].Sections[iNewPlace].PlaneSection, UF_OBJ_RED));

		//   ,    
		CustomSections[iSelEdge].RemoveAt(iSelSection);
		int iTemp = 0;
		while(iTemp<CustomSections[iSelEdge].GetCount() && CustomSections[iSelEdge][iTemp] < iNewPlace)
			iTemp++;
		CustomSections[iSelEdge].InsertAt(iTemp, iNewPlace);

		//   
		m_c_Sections.SetCurSel(iTemp);

		UGRefresh();
	}
}

void CDlgCustomSections::UGRefresh()
{
CRect Rect;

	GetWindowRect(&Rect);
	SetWindowPos(NULL, Rect.left, Rect.top%2 ? Rect.top+1 : Rect.top-1, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
}

void CDlgCustomSections::OnLbnSelchangeLsSections()
{
	if(m_c_Edges.GetCurSel()==LB_ERR || m_c_Sections.GetCurSel()==LB_ERR)
		return;

	//,   
	int iSelEdge = m_c_Edges.GetItemData(m_c_Edges.GetCurSel());

	//     (   )
	for(int i=0;i<CustomSections[iSelEdge].GetCount();i++)
	{
		if(i == m_c_Sections.GetCurSel())
			UF_CALL(UF_OBJ_set_color(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection, UF_OBJ_RED));
		else
			UF_CALL(UF_OBJ_set_color(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection, UF_OBJ_YELLOW));
	}

	UGRefresh();
}

//void CDlgCustomSections::OnBnClickedOk()
//{
//	//       CustomSections
//	/*for(int i=0;i<iEdgesNum;i++)
//	{
//		if(!Edges[i].bNothing && !Edges[i].bPS)
//		{
//			CSection *Sections = new CSection[CustomSections[i].GetCount()+2];
//			//  
//			memcpy(&Sections[0], &Edges[i].Sections[0], sizeof(CSection));
//			// ,     CustomSections
//			for(int j=0;j<CustomSections[i].GetCount();j++)
//				memcpy(&Sections[j+1], &Edges[i].Sections[CustomSections[i][j]], sizeof(CSection));
//			//  
//			memcpy(&Sections[CustomSections[i].GetCount()+1], &Edges[i].Sections[Edges[i].iSectionsNum-1], sizeof(CSection));
//
//			//  
//			delete [] Edges[i].Sections;
//
//			//      
//			Edges[i].Sections = Sections;
//			Edges[i].iSectionsNum = CustomSections[i].GetCount()+2;
//		}
//	}*/
//}

void CDlgCustomSections::OnOK()
{
	//       CustomSections
	for(int i=0;i<iEdgesNum;i++)
	{
		if(!Edges[i].bNothing && !Edges[i].bPS)
		{
			CSection *Sections = new CSection[CustomSections[i].GetCount()+2];
			//  
			memcpy(&Sections[0], &Edges[i].Sections[0], sizeof(CSection));
			// ,     CustomSections
			for(int j=0;j<CustomSections[i].GetCount();j++)
				memcpy(&Sections[j+1], &Edges[i].Sections[CustomSections[i][j]], sizeof(CSection));
			//  
			memcpy(&Sections[CustomSections[i].GetCount()+1], &Edges[i].Sections[Edges[i].iSectionsNum-1], sizeof(CSection));

			//  
			delete [] Edges[i].Sections;

			//      
			Edges[i].Sections = Sections;
			Edges[i].iSectionsNum = CustomSections[i].GetCount()+2;
		}
	}

	CDialog::OnOK();
}

BOOL CDlgCustomSections::DestroyWindow()
{
	if(m_c_Edges.GetCurSel()!=LB_ERR)
	{
		int iSelEdge = m_c_Edges.GetCurSel();

		// 
		//
		if(UF_OBJ_ask_status(Edges[iSelEdge].Sections[0].PlaneSection) == UF_OBJ_ALIVE)
			UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[0].PlaneSection));
		//
		if(UF_OBJ_ask_status(Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PlaneSection) == UF_OBJ_ALIVE)
			UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[Edges[iSelEdge].iSectionsNum-1].PlaneSection));
		// 
		for(int i=0;i<CustomSections[iSelEdge].GetCount();i++)
			if(UF_OBJ_ask_status(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection) == UF_OBJ_ALIVE)
				UF_CALL(UF_OBJ_delete_object(Edges[iSelEdge].Sections[CustomSections[iSelEdge][i]].PlaneSection));
	}

	return CDialog::DestroyWindow();
}
