// DlgOffsets.cpp : implementation file
//

#include "stdafx.h"
#include "Classes.h"
#include "PowerDesigner2.h"
#include "DlgOffsets.h"


// CDlgOffsets dialog

IMPLEMENT_DYNAMIC(CDlgOffsets, CDialog)
CDlgOffsets::CDlgOffsets(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOffsets::IDD, pParent)
	, m_Offset(0)
{
	bInitialized = false;
}

CDlgOffsets::~CDlgOffsets()
{
	delete [] SplinesGray;
}

void CDlgOffsets::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LS_EDGES, m_e_Edges);
	DDX_Text(pDX, IDC_ED_OFFSET, m_Offset);
	DDX_Control(pDX, IDC_SP_OFFSET, m_SP_Offset);
	DDX_Control(pDX, IDC_ED_OFFSET, m_c_Offset);
}


BEGIN_MESSAGE_MAP(CDlgOffsets, CDialog)
	ON_LBN_SELCHANGE(IDC_LS_EDGES, OnLbnSelchangeLsEdges)
	ON_EN_CHANGE(IDC_ED_OFFSET, OnEnChangeEdOffset)
	ON_BN_CLICKED(IDC_RB_IGNORE, OnBnClickedRbIgnore)
	ON_BN_CLICKED(IDC_RB_COUNT, OnBnClickedRbCount)
END_MESSAGE_MAP()


// CDlgOffsets message handlers

int CDlgOffsets::DoModal(tag_t *Splines_i, CEdge *Edges_i, int iEdgesNum_i)
{
	SplinesGray = new tag_t[iEdgesNum_i];
	for(int i=0;i<iEdgesNum_i;i++)
		SplinesGray[i] = NULL_TAG;

	Splines = Splines_i;
	Edges = Edges_i;
	iEdgesNum = iEdgesNum_i;
	return CDialog::DoModal();
}

BOOL CDlgOffsets::OnInitDialog()
{
	CDialog::OnInitDialog();

CString string;

	m_SP_Offset.SetRange(-200, 200);

	// 
	for(int i=0;i<iEdgesNum;i++)
	{
		string.Format(" %d", i);
		if(Edges[i].bNothing)
			m_e_Edges.SetItemData(m_e_Edges.AddString(string), i);
	}

	bInitialized = true;

	// 
	UF_CALL(UF_VIEW_fit_view(NULL_TAG, .9));
//	UGRefresh();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgOffsets::OnLbnSelchangeLsEdges()
{
	// 
	for(int i=0;i<m_e_Edges.GetCount();i++)
		if(i==m_e_Edges.GetCurSel())
		{
			if(SplinesGray[m_e_Edges.GetItemData(i)] == NULL_TAG)
				UF_CALL(UF_OBJ_set_color(Splines[m_e_Edges.GetItemData(i)], UF_OBJ_RED));
			else
				UF_CALL(UF_OBJ_set_color(SplinesGray[m_e_Edges.GetItemData(i)], UF_OBJ_RED));
		}
		else
		{
			if(SplinesGray[m_e_Edges.GetItemData(i)] == NULL_TAG)
				UF_CALL(UF_OBJ_set_color(Splines[m_e_Edges.GetItemData(i)], UF_OBJ_YELLOW));
			else
				UF_CALL(UF_OBJ_set_color(SplinesGray[m_e_Edges.GetItemData(i)], UF_OBJ_YELLOW));
		}

	m_c_Offset.EnableWindow(!Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].bIgnore);
	m_SP_Offset.EnableWindow(!Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].bIgnore);
	if(Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].bIgnore)
		CheckRadioButton(IDC_RB_IGNORE, IDC_RB_COUNT, IDC_RB_IGNORE);
	else
		CheckRadioButton(IDC_RB_IGNORE, IDC_RB_COUNT, IDC_RB_COUNT);

	m_Offset = Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].dOffset;
	UpdateData(FALSE);

	UGRefresh();
}

void CDlgOffsets::UGRefresh()
{
CRect Rect;

	GetWindowRect(&Rect);
	SetWindowPos(NULL, Rect.left, Rect.top%2 ? Rect.top+1 : Rect.top-1, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
}

void CDlgOffsets::OnEnChangeEdOffset()
{
UF_CURVE_offset_data_t OffData;
UF_STRING_t Curves;
tag_t *OffCurve;
UF_CURVE_offset_distance_data_t OffDist;
int t1=1, t2=1, t3;
CString s;

	//  
	{
		CString s1, s2, s3;
		GetDlgItemText(IDC_ED_OFFSET, s1);
		s3 = s1;
		while(s1.FindOneOf("0123456789.-")!=-1)
		{
			s2 += s1[s1.FindOneOf("0123456789.-")];
			s1.Delete(s1.FindOneOf("0123456789.-"));
		}
		while(s2.Find('.') != s2.ReverseFind('.'))
			s2.Delete(s2.ReverseFind('.'));
		while(s2.Find('-') != s2.ReverseFind('-'))
			s2.Delete(s2.ReverseFind('-'));
		if(s2.Find('-')>0)
			s2.Delete(s2.Find('-'));
		if(s2 != s3)
			SetDlgItemText(IDC_ED_OFFSET, s2);
	}

	if(bInitialized)
		if(m_e_Edges.GetCurSel()!=-1)
		{
			UpdateData();
			Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].dOffset = m_Offset;
			if(m_Offset)
			{
				if(SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())]!=NULL_TAG)
					UF_CALL(UF_OBJ_delete_object(SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())]));

				UF_CALL(UF_OBJ_set_color(Splines[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())], UF_OBJ_GRAY));

				Curves.num = 1;
				Curves.string = &t1;
				Curves.dir = &t2;
				Curves.id = &Splines[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())];

				OffCurve = &SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())];

				GetDlgItemText(IDC_ED_OFFSET, s);
				OffDist.distance = s.GetBuffer();

				OffData.approximation_tolerance = .1;
				OffData.string_tolerance = .1;
				OffData.offset_type = UF_CURVE_OFFSET_DISTANCE_NO_TRIM;
				OffData.offset_def.distance_type1 = &OffDist;
				OffData.input_curves = &Curves;

				UF_CALL(UF_CURVE_create_offset_curve(&OffData, &t3, &OffCurve));
				SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())] = *OffCurve;
				UF_CALL(UF_OBJ_set_color(SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())], UF_OBJ_RED));
				UGRefresh();
			}
			else
			{
				if(SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())]!=NULL_TAG)
				{
					UF_CALL(UF_OBJ_delete_object(SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())]));
					SplinesGray[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())] = NULL_TAG;
					UF_CALL(UF_OBJ_set_color(Splines[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())], UF_OBJ_RED));
					UGRefresh();
				}
			}
/*			{
				UF_CURVE_offset_data_t offset_data;

				offset_data.offset_type = UF_CURVE_OFFSET_DISTANCE_FILLET;
				offset_data.input_curves = &input_string;
				offset_data.approximation_tolerance = step;

				UF_MODL_ask_distance_tolerance(&offset_data.string_tolerance);

				offset_data.offset_def.distance_type1 = &offset_distance1;
				offset_distance1.distance = distance_str;

				if (dot >= 0)
				{
				offset_distance1.distance = distance_str;
				}
				else
				{ 
				offset_distance1.distance = neg_distance_str;
				}

				UF_CALL(UF_CURVE_create_offset_curve(&offset_data, &num_curves, &offset_curves)); 
			}*/
		}
}

void CDlgOffsets::OnBnClickedRbIgnore()
{
	m_c_Offset.EnableWindow(FALSE);
	m_SP_Offset.EnableWindow(FALSE);

	if(m_e_Edges.GetCurSel()!=-1)
		Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].bIgnore = true;
}

void CDlgOffsets::OnBnClickedRbCount()
{
	m_c_Offset.EnableWindow();
	m_SP_Offset.EnableWindow();

	if(m_e_Edges.GetCurSel()!=-1)
		Edges[m_e_Edges.GetItemData(m_e_Edges.GetCurSel())].bIgnore = false;
}
