// DlgWrite.cpp : implementation file
//

#include "stdafx.h"
#include "PowerDesigner2.h"
#include "DlgWrite.h"
#include "DlgFormat.h"

// CDlgWrite dialog

IMPLEMENT_DYNAMIC(CDlgWrite, CDialog)
CDlgWrite::CDlgWrite(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgWrite::IDD, pParent)
	, m_bOuter(TRUE)
	, m_bOuterEdge(FALSE)
	, m_bHole(FALSE)
	, m_bHoleEdge(FALSE)
	, m_bHoleAll(FALSE)
	, m_bPunch(FALSE)
	, m_bPunchEdge(FALSE)
	, m_bPunchAll(FALSE)
	, m_bPressIn(FALSE)
	, m_bPressInEdge(FALSE)
	, m_bPressInAll(FALSE)
	, m_bOuterEdgeEmpty(TRUE)
{
}

CDlgWrite::~CDlgWrite()
{
	bOuter = bOuterEdge = true;
	bHole = bHoleEdge = bHoleAll = bPunch = bPunchEdge = bPunchAll = bPressIn = bPressInEdge = bPressInAll = false;
}

void CDlgWrite::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CB_WR_OUTER, m_CB_Wr_Outer);
	DDX_Control(pDX, IDC_CB_WR_OUTER_EDGE, m_CB_Wr_Outer_Edge);
	DDX_Control(pDX, IDC_CB_WR_HOLE, m_CB_Wr_Hole);
	DDX_Control(pDX, IDC_CB_WR_HOLE_EDGE, m_CB_Wr_Hole_Edge);
	DDX_Control(pDX, IDC_CB_WR_HOLE_ALL, m_CB_Wr_Hole_All);
	DDX_Control(pDX, IDC_CB_WR_PUNCH, m_CB_Wr_Punch);
	DDX_Control(pDX, IDC_CB_WR_PUNCH_EDGE, m_CB_Wr_Punch_Edge);
	DDX_Control(pDX, IDC_CB_WR_PUNCH_ALL, m_CB_Wr_Punch_All);
	DDX_Control(pDX, IDC_CB_WR_PRESSIN, m_CB_Wr_PressIn);
	DDX_Control(pDX, IDC_CB_WR_PRESSIN_EDGE, m_CB_Wr_PressIn_Edge);
	DDX_Control(pDX, IDC_CB_WR_PRESSIN_ALL, m_CB_Wr_PressIn_All);
	DDX_Control(pDX, IDC_BUT_WR_OUTER, m_But_Wr_Outer);
	DDX_Control(pDX, IDC_BUT_WR_OUTER_EDGE, m_But_Wr_Outer_Edge);
	DDX_Control(pDX, IDC_BUT_WR_HOLE, m_But_Wr_Hole);
	DDX_Control(pDX, IDC_BUT_WR_HOLE_EDGE, m_But_Wr_Hole_Edge);
	DDX_Control(pDX, IDC_BUT_WR_HOLE_ALL, m_But_Wr_Hole_All);
	DDX_Control(pDX, IDC_BUT_WR_PUNCH, m_But_Wr_Punch);
	DDX_Control(pDX, IDC_BUT_WR_PUNCH_EDGE, m_But_Wr_Punch_Edge);
	DDX_Control(pDX, IDC_BUT_WR_PUNCH_ALL, m_But_Wr_Punch_All);
	DDX_Control(pDX, IDC_BUT_WR_PRESSIN, m_But_Wr_PressIn);
	DDX_Control(pDX, IDC_BUT_WR_PRESSIN_EDGE, m_But_Wr_PressIn_Edge);
	DDX_Control(pDX, IDC_BUT_WR_PRESSIN_ALL, m_But_Wr_PressIn_All);
	DDX_Control(pDX, IDOK, m_But_OK);
	DDX_Check(pDX, IDC_CB_WR_OUTER, m_bOuter);
	DDX_Check(pDX, IDC_CB_WR_OUTER_EDGE, m_bOuterEdge);
	DDX_Check(pDX, IDC_CB_WR_HOLE, m_bHole);
	DDX_Check(pDX, IDC_CB_WR_HOLE_EDGE, m_bHoleEdge);
	DDX_Check(pDX, IDC_CB_WR_HOLE_ALL, m_bHoleAll);
	DDX_Check(pDX, IDC_CB_WR_PUNCH, m_bPunch);
	DDX_Check(pDX, IDC_CB_WR_PUNCH_EDGE, m_bPunchEdge);
	DDX_Check(pDX, IDC_CB_WR_PUNCH_ALL, m_bPunchAll);
	DDX_Check(pDX, IDC_CB_WR_PRESSIN, m_bPressIn);
	DDX_Check(pDX, IDC_CB_WR_PRESSIN_EDGE, m_bPressInEdge);
	DDX_Check(pDX, IDC_CB_WR_PRESSIN_ALL, m_bPressInAll);
	DDX_Check(pDX, IDC_CB_WR_OUTER_EDGE_EMPTY, m_bOuterEdgeEmpty);
	DDX_Control(pDX, IDC_CB_WR_OUTER_EDGE_EMPTY, m_CB_Wr_Outer_Edge_Empty);
}


BEGIN_MESSAGE_MAP(CDlgWrite, CDialog)
	ON_BN_CLICKED(IDC_CB_WR_OUTER, OnBnClickedCbWrOuter)
	ON_BN_CLICKED(IDC_CB_WR_HOLE, OnBnClickedCbWrHole)
	ON_BN_CLICKED(IDC_CB_WR_PUNCH, OnBnClickedCbWrPunch)
	ON_BN_CLICKED(IDC_CB_WR_PRESSIN, OnBnClickedCbWrPressin)
	ON_BN_CLICKED(IDC_CB_WR_OUTER_EDGE, OnBnClickedCbWrOuterEdge)
	ON_BN_CLICKED(IDC_CB_WR_HOLE_EDGE, OnBnClickedCbWrHoleEdge)
	ON_BN_CLICKED(IDC_CB_WR_HOLE_ALL, OnBnClickedCbWrHoleAll)
	ON_BN_CLICKED(IDC_CB_WR_PUNCH_EDGE, OnBnClickedCbWrPunchEdge)
	ON_BN_CLICKED(IDC_CB_WR_PUNCH_ALL, OnBnClickedCbWrPunchAll)
	ON_BN_CLICKED(IDC_CB_WR_PRESSIN_EDGE, OnBnClickedCbWrPressinEdge)
	ON_BN_CLICKED(IDC_CB_WR_PRESSIN_ALL, OnBnClickedCbWrPressinAll)
	ON_BN_CLICKED(IDC_BUT_WR_OUTER, OnBnClickedButWrOuter)
	ON_BN_CLICKED(IDC_BUT_WR_OUTER_EDGE, OnBnClickedButWrOuterEdge)
	ON_BN_CLICKED(IDC_BUT_WR_HOLE, OnBnClickedButWrHole)
	ON_BN_CLICKED(IDC_BUT_WR_HOLE_EDGE, OnBnClickedButWrHoleEdge)
	ON_BN_CLICKED(IDC_BUT_WR_HOLE_ALL, OnBnClickedButWrHoleAll)
	ON_BN_CLICKED(IDC_BUT_WR_PUNCH, OnBnClickedButWrPunch)
	ON_BN_CLICKED(IDC_BUT_WR_PUNCH_EDGE, OnBnClickedButWrPunchEdge)
	ON_BN_CLICKED(IDC_BUT_WR_PUNCH_ALL, OnBnClickedButWrPunchAll)
	ON_BN_CLICKED(IDC_BUT_WR_PRESSIN, OnBnClickedButWrPressin)
	ON_BN_CLICKED(IDC_BUT_WR_PRESSIN_EDGE, OnBnClickedButWrPressinEdge)
	ON_BN_CLICKED(IDC_BUT_WR_PRESSIN_ALL, OnBnClickedButWrPressinAll)
END_MESSAGE_MAP()


// CDlgWrite message handlers

void CDlgWrite::OnBnClickedCbWrOuter()
{
	if(m_CB_Wr_Outer.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_Outer_Edge.EnableWindow();
		m_But_Wr_Outer.EnableWindow();
		m_But_Wr_Outer_Edge.EnableWindow();
		m_CB_Wr_Outer_Edge_Empty.EnableWindow();

		m_CB_Wr_Outer_Edge.SetCheck(BST_CHECKED);
	}
	else
	{
		m_CB_Wr_Outer_Edge.EnableWindow(FALSE);
		m_But_Wr_Outer.EnableWindow(FALSE);
		m_But_Wr_Outer_Edge.EnableWindow(FALSE);
		m_CB_Wr_Outer_Edge_Empty.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Outer.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Hole.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Punch.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_PressIn.GetCheck()==BST_UNCHECKED)
		m_But_OK.EnableWindow(FALSE);
	else
		m_But_OK.EnableWindow();
}

void CDlgWrite::OnBnClickedCbWrOuterEdge()
{
	if(m_CB_Wr_Outer_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_Outer_Edge.EnableWindow();
	else
		m_But_Wr_Outer_Edge.EnableWindow(FALSE);
}

void CDlgWrite::OnBnClickedCbWrHole()
{
	if(m_CB_Wr_Hole.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_Hole_Edge.EnableWindow();
		m_CB_Wr_Hole_All.EnableWindow();
		m_But_Wr_Hole.EnableWindow();
		m_But_Wr_Hole_Edge.EnableWindow();
		m_But_Wr_Hole_All.EnableWindow();

		m_CB_Wr_Hole_Edge.SetCheck(BST_CHECKED);
		m_CB_Wr_Hole_All.SetCheck(BST_CHECKED);
	}
	else
	{
		m_CB_Wr_Hole_Edge.EnableWindow(FALSE);
		m_CB_Wr_Hole_All.EnableWindow(FALSE);
		m_But_Wr_Hole.EnableWindow(FALSE);
		m_But_Wr_Hole_Edge.EnableWindow(FALSE);
		m_But_Wr_Hole_All.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Outer.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Hole.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Punch.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_PressIn.GetCheck()==BST_UNCHECKED)
		m_But_OK.EnableWindow(FALSE);
	else
		m_But_OK.EnableWindow();
}

void CDlgWrite::OnBnClickedCbWrHoleEdge()
{
	if(m_CB_Wr_Hole_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_Hole_Edge.EnableWindow();
	else
		m_But_Wr_Hole_Edge.EnableWindow(FALSE);
}

void CDlgWrite::OnBnClickedCbWrHoleAll()
{
	if(m_CB_Wr_Hole_All.GetCheck()==BST_CHECKED)
		m_But_Wr_Hole_All.EnableWindow();
	else
		m_But_Wr_Hole_All.EnableWindow(FALSE);
}

void CDlgWrite::OnBnClickedCbWrPunch()
{
	if(m_CB_Wr_Punch.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_Punch_Edge.EnableWindow();
		m_CB_Wr_Punch_All.EnableWindow();
		m_But_Wr_Punch.EnableWindow();
		m_But_Wr_Punch_Edge.EnableWindow();
		m_But_Wr_Punch_All.EnableWindow();

		m_CB_Wr_Punch_Edge.SetCheck(BST_CHECKED);
		m_CB_Wr_Punch_All.SetCheck(BST_CHECKED);
	}
	else
	{
		m_CB_Wr_Punch_Edge.EnableWindow(FALSE);
		m_CB_Wr_Punch_All.EnableWindow(FALSE);
		m_But_Wr_Punch.EnableWindow(FALSE);
		m_But_Wr_Punch_Edge.EnableWindow(FALSE);
		m_But_Wr_Punch_All.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Outer.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Hole.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Punch.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_PressIn.GetCheck()==BST_UNCHECKED)
		m_But_OK.EnableWindow(FALSE);
	else
		m_But_OK.EnableWindow();
}

void CDlgWrite::OnBnClickedCbWrPunchEdge()
{
	if(m_CB_Wr_Punch_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_Punch_Edge.EnableWindow();
	else
		m_But_Wr_Punch_Edge.EnableWindow(FALSE);
}

void CDlgWrite::OnBnClickedCbWrPunchAll()
{
	if(m_CB_Wr_Punch_All.GetCheck()==BST_CHECKED)
		m_But_Wr_Punch_All.EnableWindow();
	else
		m_But_Wr_Punch_All.EnableWindow(FALSE);
}

void CDlgWrite::OnBnClickedCbWrPressin()
{
	if(m_CB_Wr_PressIn.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_PressIn_Edge.EnableWindow();
		m_CB_Wr_PressIn_All.EnableWindow();
		m_But_Wr_PressIn.EnableWindow();
		m_But_Wr_PressIn_Edge.EnableWindow();
		m_But_Wr_PressIn_All.EnableWindow();

		m_CB_Wr_PressIn_Edge.SetCheck(BST_CHECKED);
		m_CB_Wr_PressIn_All.SetCheck(BST_CHECKED);
	}
	else
	{
		m_CB_Wr_PressIn_Edge.EnableWindow(FALSE);
		m_CB_Wr_PressIn_All.EnableWindow(FALSE);
		m_But_Wr_PressIn.EnableWindow(FALSE);
		m_But_Wr_PressIn_Edge.EnableWindow(FALSE);
		m_But_Wr_PressIn_All.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Outer.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Hole.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Punch.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_PressIn.GetCheck()==BST_UNCHECKED)
		m_But_OK.EnableWindow(FALSE);
	else
		m_But_OK.EnableWindow();
}

void CDlgWrite::OnBnClickedCbWrPressinEdge()
{
	if(m_CB_Wr_PressIn_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_PressIn_Edge.EnableWindow();
	else
		m_But_Wr_PressIn_Edge.EnableWindow(FALSE);
}

void CDlgWrite::OnBnClickedCbWrPressinAll()
{
	if(m_CB_Wr_PressIn_All.GetCheck()==BST_CHECKED)
		m_But_Wr_PressIn_All.EnableWindow();
	else
		m_But_Wr_PressIn_All.EnableWindow(FALSE);
}

BOOL CDlgWrite::OnInitDialog()
{
	CDialog::OnInitDialog();

//	m_CB_Wr_Outer.SetCheck(BST_CHECKED);
//	m_CB_Wr_Outer_Edge.SetCheck(BST_CHECKED);

	if(m_CB_Wr_Outer.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_Outer_Edge.EnableWindow();
		m_But_Wr_Outer.EnableWindow();
		m_But_Wr_Outer_Edge.EnableWindow();
		m_CB_Wr_Outer_Edge_Empty.EnableWindow();
	}
	else
	{
		m_CB_Wr_Outer_Edge.EnableWindow(FALSE);
		m_But_Wr_Outer.EnableWindow(FALSE);
		m_But_Wr_Outer_Edge.EnableWindow(FALSE);
		m_CB_Wr_Outer_Edge_Empty.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Outer_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_Outer_Edge.EnableWindow();
	else
		m_But_Wr_Outer_Edge.EnableWindow(FALSE);

	if(m_CB_Wr_Hole.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_Hole_Edge.EnableWindow();
		m_CB_Wr_Hole_All.EnableWindow();
		m_But_Wr_Hole.EnableWindow();
		m_But_Wr_Hole_Edge.EnableWindow();
		m_But_Wr_Hole_All.EnableWindow();
	}
	else
	{
		m_CB_Wr_Hole_Edge.EnableWindow(FALSE);
		m_CB_Wr_Hole_All.EnableWindow(FALSE);
		m_But_Wr_Hole.EnableWindow(FALSE);
		m_But_Wr_Hole_Edge.EnableWindow(FALSE);
		m_But_Wr_Hole_All.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Hole_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_Hole_Edge.EnableWindow();
	else
		m_But_Wr_Hole_Edge.EnableWindow(FALSE);

	if(m_CB_Wr_Hole_All.GetCheck()==BST_CHECKED)
		m_But_Wr_Hole_All.EnableWindow();
	else
		m_But_Wr_Hole_All.EnableWindow(FALSE);

	if(m_CB_Wr_Punch.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_Punch_Edge.EnableWindow();
		m_CB_Wr_Punch_All.EnableWindow();
		m_But_Wr_Punch.EnableWindow();
		m_But_Wr_Punch_Edge.EnableWindow();
		m_But_Wr_Punch_All.EnableWindow();
	}
	else
	{
		m_CB_Wr_Punch_Edge.EnableWindow(FALSE);
		m_CB_Wr_Punch_All.EnableWindow(FALSE);
		m_But_Wr_Punch.EnableWindow(FALSE);
		m_But_Wr_Punch_Edge.EnableWindow(FALSE);
		m_But_Wr_Punch_All.EnableWindow(FALSE);
	}

	if(m_CB_Wr_Punch_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_Punch_Edge.EnableWindow();
	else
		m_But_Wr_Punch_Edge.EnableWindow(FALSE);

	if(m_CB_Wr_Punch_All.GetCheck()==BST_CHECKED)
		m_But_Wr_Punch_All.EnableWindow();
	else
		m_But_Wr_Punch_All.EnableWindow(FALSE);

	if(m_CB_Wr_PressIn.GetCheck()==BST_CHECKED)
	{
		m_CB_Wr_PressIn_Edge.EnableWindow();
		m_CB_Wr_PressIn_All.EnableWindow();
		m_But_Wr_PressIn.EnableWindow();
		m_But_Wr_PressIn_Edge.EnableWindow();
		m_But_Wr_PressIn_All.EnableWindow();
	}
	else
	{
		m_CB_Wr_PressIn_Edge.EnableWindow(FALSE);
		m_CB_Wr_PressIn_All.EnableWindow(FALSE);
		m_But_Wr_PressIn.EnableWindow(FALSE);
		m_But_Wr_PressIn_Edge.EnableWindow(FALSE);
		m_But_Wr_PressIn_All.EnableWindow(FALSE);
	}

	if(m_CB_Wr_PressIn_Edge.GetCheck()==BST_CHECKED)
		m_But_Wr_PressIn_Edge.EnableWindow();
	else
		m_But_Wr_PressIn_Edge.EnableWindow(FALSE);

	if(m_CB_Wr_PressIn_All.GetCheck()==BST_CHECKED)
		m_But_Wr_PressIn_All.EnableWindow();
	else
		m_But_Wr_PressIn_All.EnableWindow(FALSE);


	if(m_CB_Wr_Outer.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Hole.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_Punch.GetCheck()==BST_UNCHECKED &&
		m_CB_Wr_PressIn.GetCheck()==BST_UNCHECKED)
		m_But_OK.EnableWindow(FALSE);
	else
		m_But_OK.EnableWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgWrite::OnBnClickedButWrOuter()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatOuter;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_OUTER;

	if(DlgFormat.DoModal()==IDOK)
		sFormatOuter = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrOuterEdge()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatOuterEdge;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_OUTER_EDGE;

	if(DlgFormat.DoModal()==IDOK)
		sFormatOuterEdge = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrHole()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatHole;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_HOLE;

	if(DlgFormat.DoModal()==IDOK)
		sFormatHole = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrHoleEdge()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatHoleEdge;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_HOLE_EDGE;

	if(DlgFormat.DoModal()==IDOK)
		sFormatHoleEdge = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrHoleAll()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatHoleAll;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_HOLE_ALL;

	if(DlgFormat.DoModal()==IDOK)
		sFormatHoleAll = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrPunch()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatPunch;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_PUNCH;

	if(DlgFormat.DoModal()==IDOK)
		sFormatPunch = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrPunchEdge()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatPunchEdge;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_PUNCH_EDGE;

	if(DlgFormat.DoModal()==IDOK)
		sFormatPunchEdge = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrPunchAll()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatPunchAll;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_PUNCH_ALL;

	if(DlgFormat.DoModal()==IDOK)
		sFormatPunchAll = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrPressin()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatPressIn;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_PRESSIN;

	if(DlgFormat.DoModal()==IDOK)
		sFormatPressIn = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrPressinEdge()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatPressInEdge;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_PRESSIN_EDGE;

	if(DlgFormat.DoModal()==IDOK)
		sFormatPressInEdge = DlgFormat.m_sFormat;
}

void CDlgWrite::OnBnClickedButWrPressinAll()
{
CDlgFormat DlgFormat;

	DlgFormat.m_sFormat = sFormatPressInAll;
	DlgFormat.iPictureID = IDB_BMP_FORMAT_PRESSIN_ALL;

	if(DlgFormat.DoModal()==IDOK)
		sFormatPressInAll = DlgFormat.m_sFormat;
}
