//  
#include "StdAfx.h"

#include "Classes.h"
#include "PowerDesigner2.h"
#include "DlgWrite.h"
#include "DlgSettings.h"
#include "DlgCorrectAngles.h"
#include "DlgCustomSections.h"

int MainDemo(void)
{
static char title[] = "CHOOSE OPTION";
static char menu[7][37+1] = {
				"1.Scan part",
				"1a.  ",
				"2. ",
				"2a.  ",
				"3.Create swage",
				"4.  ",
				" "};
int iCount=0, iChoice, iResponse, iIndex=0;
double dCursor[3];
tag_t Features, View, PartTag;
CPart Part, PartManual;
CDlgWrite DlgWrite;
CDlgSettings DlgSettings;
CDlgCorrectAngles DlgCorrectAngles;
CDlgCustomSections DlgCustomSections;
CFile File;
CString str1, str2;
char cOutNumber[133] = "1000";
uf_list_p_t LFeatures;

	DlgCorrectAngles.m_Number = 100;

	//   
	DlgWrite.sFormatOuter = "{0x},{0y},{0z}, {1x},{1y},{1z}, {2x},{2y},{2z}, {3x},{3y},{3z}, {4x},{4y},{4z}, {5x},{5y},{5z}, {6x},{6y},{6z}, {7}, {8}, {9}, {10g}, {11}, {13}, {14}, {15}, {16}\r\n";
	DlgWrite.sFormatOuterEdge = ".  : {0}, : {1}, : {2}.\r\n";
	DlgWrite.sFormatHole = "{0x},{0y},{0z}\r\n";
	DlgWrite.sFormatHoleEdge = " .  : {0}\r\n";
	DlgWrite.sFormatHoleAll = ".  : {0}\r\n";
	DlgWrite.sFormatPunch = "{0x},{0y},{0z}, {1x},{1y},{1z}, {2x},{2y},{2z}, {3x},{3y},{3z}\r\n";
	DlgWrite.sFormatPunchEdge = " .  : {0}\r\n";
	DlgWrite.sFormatPunchAll = ".  : {0}\r\n";
	DlgWrite.sFormatPressIn = "{0x},{0y},{0z}, {1x},{1y},{1z}, {2x},{2y},{2z}, {3x},{3y},{3z}, {4x},{4y},{4z}, {5x},{5y},{5z}\r\n";
	DlgWrite.sFormatPressInEdge = " .  : {0}\r\n";
	DlgWrite.sFormatPressInAll = ".  : {0}\r\n";

	while (1)
	{
		iChoice = uc1603(title, 0, menu, 7);

		if (iChoice == 1 || iChoice == 2) 
			return 0;

		switch(iChoice)
		{
		case 5:	//"1. "
			if(!UF_CALL(UF_UI_select_with_single_dialog(" ", "", UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY, NULL, NULL, &iResponse, &PartTag, dCursor,  &View)))
				if(iResponse==UF_UI_OBJECT_SELECTED || iResponse==UF_UI_OBJECT_SELECTED_BY_NAME)
				{
					UF_CALL(UF_MODL_ask_body_feats(PartTag, &LFeatures));
					UF_CALL(UF_MODL_ask_list_item(LFeatures, 0, &Features));
					UF_CALL(UF_MODL_delete_list(&LFeatures));
					UF_DISP_set_highlight(PartTag,0);
					if(DlgCorrectAngles.DoModal()==IDOK)
					{
						Part.ScanPart(Features, DlgCorrectAngles.m_Number);
						Part.Correct(DlgCorrectAngles.m_E, DlgCorrectAngles.m_K, DlgCorrectAngles.m_N);
					}
				}
			break;
		case 6:	//"1a.  "
			if(DlgCustomSections.DoModal(Part.Edges, Part.iEdgesNum)==IDOK)
			{
			}
			break;
		case 7:	//"2. "
			if(DlgWrite.DoModal()==IDOK)
			{
				CFileDialog FD(TRUE, "txt", "", OFN_CREATEPROMPT|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST, "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");

				if(FD.DoModal()==IDOK)
				{
					File.Open(FD.GetPathName(), CFile::modeCreate|CFile::modeWrite);

					if(DlgWrite.m_bOuter)
					{
						if(DlgWrite.m_bOuterEdge)
							str1 = DlgWrite.sFormatOuterEdge;
						else
							str1 = "";

						for(int i=0;i<Part.iEdgesNum;i++)
							if(DlgWrite.m_bOuterEdgeEmpty || (!DlgWrite.m_bOuterEdgeEmpty && !Part.Edges[i].bNothing))
							{
								Part.Edges[i].WriteEdge(&File, str1, DlgWrite.sFormatOuter, 0);
								iIndex += Part.Edges[i].iSectionsNum;
							}
					}

					if(DlgWrite.m_bHole)
					{
						if(DlgWrite.m_bHoleEdge)
							str1 = DlgWrite.sFormatHoleEdge;
						else
							str1 = "";
						if(DlgWrite.m_bHoleAll)
							str2 = DlgWrite.sFormatHoleAll;
						else
							str2 = "";

						for(int i=0;i<Part.iHolesNum;i++)
							Part.Holes[i].WriteHole(&File, str2, str1, DlgWrite.sFormatHole);
					}

					if(DlgWrite.m_bPunch)
					{
						if(DlgWrite.m_bPunchEdge)
							str1 = DlgWrite.sFormatPunchEdge;
						else
							str1 = "";
						if(DlgWrite.m_bPunchAll)
							str2 = DlgWrite.sFormatPunchAll;
						else
							str2 = "";

						for(int i=0;i<Part.iPunchesNum;i++)
							Part.Punches[i].WritePunch(&File, str2, str1, DlgWrite.sFormatPunch);
					}

					if(DlgWrite.m_bPressIn)
					{
						if(DlgWrite.m_bPressInEdge)
							str1 = DlgWrite.sFormatPressInEdge;
						else
							str1 = "";
						if(DlgWrite.m_bPressInAll)
							str2 = DlgWrite.sFormatPressInAll;
						else
							str2 = "";

						for(int i=0;i<Part.iPressInsNum;i++)
							Part.PressIns[i].WritePressIn(&File, str2, str1, DlgWrite.sFormatPressIn);
					}

					File.Close();
				}
			}
			break;
		case 8: //"2a.  "
			{
				CFileDialog FD(TRUE, "txt", "", OFN_CREATEPROMPT|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST, "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");

				if(FD.DoModal()==IDOK)
				{
					File.Open(FD.GetPathName(), CFile::modeCreate|CFile::modeWrite);

					Part.WriteParameters(&File);

					File.Close();
				}
			}
            
			break;
		case 9:	//"3.  "
			//Demo
			{
				PartTag = UF_PART_ask_display_part();

				tag_t Base, Press, Bush;
				int iNumber = 0;
				CString string;

				UF_PART_set_display_part(PartTag);

				Base = Part.CreateBase();
				UF_CALL(UF_OBJ_set_color(Base, UF_OBJ_AQUAMARINE));
				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchBase(&Base, Part.CalcMinBaseHeight(), Part.Service.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInBase(&Base, Part.Service.dBaseNormal);

				Press = Part.CreatePress();
				UF_CALL(UF_OBJ_set_color(Press, UF_OBJ_PINK));
				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchPress(&Press, Part.Service.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInPress(&Press, Part.Service.dBaseNormal, Part.t);

				for(int i=0;i<Part.iPressInsNum;i++)
				{
					Bush = Part.PressIns[i].CreatePressInBush(Part.Service.dBaseNormal, Part.t);
					UF_CALL(UF_OBJ_set_color(Bush, UF_OBJ_ORANGE));
				}
			}
			//Work
/*			{
				tag_t UGPart, Base, Press;
				int iNumber = 0;
				CString string;

				Part.AskParametersInteractive();

				//  
				string.Format("Base %d", iNumber);
				while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
					string.Format("Base %d", ++iNumber);

				Base = Part.CreateBase();
				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchBase(&Base, Part.CalcMinBaseHeight(), Part.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInBase(&Base, Part.dBaseNormal);

				//  
				string.Format("Press %d", iNumber);
				while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
					string.Format("Press %d", ++iNumber);

				Press = Part.CreatePress();

				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchPress(&Press, Part.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInPress(&Press, Part.dBaseNormal, Part.t);

				for(int i=0;i<Part.iPressInsNum;i++)
				{
					//  
					string.Format("Bush %d", iNumber);
					while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
						string.Format("Bush %d", ++iNumber);
					Part.PressIns[i].CreatePressInBush(Part.dBaseNormal, Part.t);
				}
			}*/
			break;
		case 10:	//"4.  "
			{
				tag_t UGPart, Involute;
				int iNumber = 0;
				CString string;

				//  
				string.Format("Matrix %d", iNumber);
				while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
					string.Format("Matrix %d", ++iNumber);

				Involute = Part.CreateInvolute();
			}
			break;
		case 11:	//" "

/*			{
				double dPoint[3];
				for(int i=0;i<Part.iEdgesNum;i++)
					for(int j=0;j<Part.Edges[i].iSectionsNum;j++)
					{
						Part.Edges[i].Sections[j].PointRounding.Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &PartTag));
						Part.Edges[i].Sections[j].PointBevel.Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &PartTag));
					}
					break;
			}*/

/*			{
				double dPoint[3];
				for(int i=0;i<Part.iPressEdgesNum;i++)
					for(int j=0;j<Part.iPressPointsNum[i];j++)
					{
						Part.PointsPress[i][j].Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &PartTag));
					}
					break;
			}*/

//			DlgSettings.m_DistTol = dG_DistTol;
//			DlgSettings.m_InnerCoef = dG_InnerCoef;
			if(DlgSettings.DoModal()==IDOK)
			{
				dG_DistTol = DlgSettings.m_DistTol;
				dG_InnerCoef = DlgSettings.m_InnerCoef;
				iSplinesDegree = DlgSettings.m_SplinesDegree;
				dG_BaseAdditionalThickness = DlgSettings.m_AdditionalThickness;
				bG_SingleRadius = DlgSettings.m_SingleRadius;
				bG_SingleH = DlgSettings.m_SingleH;
				dG_PressThickness = DlgSettings.m_PressThickness;
				dG_BushInPressThickness = DlgSettings.m_BushInPressThickness;
				dG_RoundingsRadius = DlgSettings.m_RoundingsRadius;
			}
			break;
		}
	}

	return 0;
}

int Main(void)
{
static char title[] = "CHOOSE OPTION";
static char menu[7][37+1] = {
				"1. ",
				"1a.  ",
				"2. ",
				"2a.  ",
				"3.  ",
				"4.  ",
				" "};
int iCount=0, iChoice, iResponse, iIndex=0;
double dCursor[3];
tag_t Features, View, PartTag;
CPart Part, PartManual;
CDlgWrite DlgWrite;
CDlgSettings DlgSettings;
CDlgCorrectAngles DlgCorrectAngles;
CDlgCustomSections DlgCustomSections;
CFile File;
CString str1, str2;
char cOutNumber[133] = "1000";
uf_list_p_t LFeatures;

	//   
	DlgWrite.sFormatOuter = "{0x},{0y},{0z}, {1x},{1y},{1z}, {2x},{2y},{2z}, {3x},{3y},{3z}, {4x},{4y},{4z}, {5x},{5y},{5z}, {6x},{6y},{6z}, {7}, {8}, {9}, {10g}, {11}, {13}, {14}, {15}, {16}\r\n";
	DlgWrite.sFormatOuterEdge = ".  : {0}, : {1}, : {2}.\r\n";
	DlgWrite.sFormatHole = "{0x},{0y},{0z}\r\n";
	DlgWrite.sFormatHoleEdge = " .  : {0}\r\n";
	DlgWrite.sFormatHoleAll = ".  : {0}\r\n";
	DlgWrite.sFormatPunch = "{0x},{0y},{0z}, {1x},{1y},{1z}, {2x},{2y},{2z}, {3x},{3y},{3z}\r\n";
	DlgWrite.sFormatPunchEdge = " .  : {0}\r\n";
	DlgWrite.sFormatPunchAll = ".  : {0}\r\n";
	DlgWrite.sFormatPressIn = "{0x},{0y},{0z}, {1x},{1y},{1z}, {2x},{2y},{2z}, {3x},{3y},{3z}, {4x},{4y},{4z}, {5x},{5y},{5z}\r\n";
	DlgWrite.sFormatPressInEdge = " .  : {0}\r\n";
	DlgWrite.sFormatPressInAll = ".  : {0}\r\n";

	while (1)
	{
		iChoice = uc1603(title, 0, menu, 7);

		if (iChoice == 1 || iChoice == 2) 
		{
/*{
	tag_t F=0, P=UF_ASSEM_ask_work_part();
	UF_CURVE_trim_s Trim;
	int enttype = UF_feature_type;

	do
	{
		UF_CALL(UF_OBJ_cycle_objs_in_part(P, enttype, &F));
		if(F == NULL_TAG) break;

		UF_CALL(UF_CURVE_ask_trim(F, &Trim));
	}while(F);
}*/

/*{
	tag_t F=0, P=UF_ASSEM_ask_work_part();
	UF_MODL_edge_blend_data_s Blend;
	char *Type;
	int enttype = UF_feature_type;

	do
	{
		UF_CALL(UF_OBJ_cycle_objs_in_part(P, enttype, &F));
		if(F == NULL_TAG) break;

		UF_CALL(UF_MODL_ask_feat_name(F, &Type));
		if(Type == "Z")
			UF_CALL(UF_MODL_ask_edge_blend(F, &Blend));
	}while(F);
}*/

			return 0;
		}

		switch(iChoice)
		{
		case 5:	//"1. "
			if(!UF_CALL(UF_UI_select_with_single_dialog(" ", "", UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY, NULL, NULL, &iResponse, &PartTag, dCursor,  &View)))
				if(iResponse==UF_UI_OBJECT_SELECTED || iResponse==UF_UI_OBJECT_SELECTED_BY_NAME)
				{
					UF_CALL(UF_MODL_ask_body_feats(PartTag, &LFeatures));
					UF_CALL(UF_MODL_ask_list_item(LFeatures, 0, &Features));
					UF_CALL(UF_MODL_delete_list(&LFeatures));
					UF_DISP_set_highlight(PartTag,0);
					if(DlgCorrectAngles.DoModal()==IDOK)
					{
						Part.ScanPart(Features, DlgCorrectAngles.m_Number);
						Part.Correct(DlgCorrectAngles.m_E, DlgCorrectAngles.m_K, DlgCorrectAngles.m_N);
					}
				}
/*			if(!UF_CALL(UF_UI_select_with_single_dialog(" ", "", UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY, NULL, NULL, &iResponse, &PartTag, dCursor,  &View)))
				if(iResponse==UF_UI_OBJECT_SELECTED || iResponse==UF_UI_OBJECT_SELECTED_BY_NAME)
				{
					UF_CALL(UF_MODL_ask_body_feats(PartTag, &LFeatures));
					UF_CALL(UF_MODL_ask_list_item(LFeatures, 0, &Features));
					UF_CALL(UF_MODL_delete_list(&LFeatures));
					uc1600("   ", cOutNumber, &iResponse);
					UF_DISP_set_highlight(PartTag,0);
					Part.ScanPart(Features, atoi(cOutNumber));
				}*/
/*			if(!UF_CALL(UF_UI_select_feature(" ", NULL, &iCount, &Features, &iResponse)) && iResponse==UF_UI_OK && iCount)
			{
				uc1600("   ", cOutNumber, &iResponse);
				Part.ScanPart(Features[0], atoi(cOutNumber));
				UF_free(Features);
			}*/
			break;
		case 6:	//"1a.  "
			if(DlgCustomSections.DoModal(Part.Edges, Part.iEdgesNum)==IDOK)
			{
			}
			break;
		case 7:	//"2. "
			if(DlgWrite.DoModal()==IDOK)
			{
				CFileDialog FD(TRUE, "txt", "", OFN_CREATEPROMPT|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST, "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");

				if(FD.DoModal()==IDOK)
				{
					File.Open(FD.GetPathName(), CFile::modeCreate|CFile::modeWrite);

					if(DlgWrite.m_bOuter)
					{
						if(DlgWrite.m_bOuterEdge)
							str1 = DlgWrite.sFormatOuterEdge;
						else
							str1 = "";

						for(int i=0;i<Part.iEdgesNum;i++)
							if(DlgWrite.m_bOuterEdgeEmpty || (!DlgWrite.m_bOuterEdgeEmpty && !Part.Edges[i].bNothing))
							{
								Part.Edges[i].WriteEdge(&File, str1, DlgWrite.sFormatOuter, 0);
								iIndex += Part.Edges[i].iSectionsNum;
							}
					}

					if(DlgWrite.m_bHole)
					{
						if(DlgWrite.m_bHoleEdge)
							str1 = DlgWrite.sFormatHoleEdge;
						else
							str1 = "";
						if(DlgWrite.m_bHoleAll)
							str2 = DlgWrite.sFormatHoleAll;
						else
							str2 = "";

						for(int i=0;i<Part.iHolesNum;i++)
							Part.Holes[i].WriteHole(&File, str2, str1, DlgWrite.sFormatHole);
					}

					if(DlgWrite.m_bPunch)
					{
						if(DlgWrite.m_bPunchEdge)
							str1 = DlgWrite.sFormatPunchEdge;
						else
							str1 = "";
						if(DlgWrite.m_bPunchAll)
							str2 = DlgWrite.sFormatPunchAll;
						else
							str2 = "";

						for(int i=0;i<Part.iPunchesNum;i++)
							Part.Punches[i].WritePunch(&File, str2, str1, DlgWrite.sFormatPunch);
					}

					if(DlgWrite.m_bPressIn)
					{
						if(DlgWrite.m_bPressInEdge)
							str1 = DlgWrite.sFormatPressInEdge;
						else
							str1 = "";
						if(DlgWrite.m_bPressInAll)
							str2 = DlgWrite.sFormatPressInAll;
						else
							str2 = "";

						for(int i=0;i<Part.iPressInsNum;i++)
							Part.PressIns[i].WritePressIn(&File, str2, str1, DlgWrite.sFormatPressIn);
					}

					File.Close();
				}
			}
			break;
		case 8: //"2a.  "
			{
				CFileDialog FD(TRUE, "txt", "", OFN_CREATEPROMPT|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST, "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");

				if(FD.DoModal()==IDOK)
				{
					File.Open(FD.GetPathName(), CFile::modeCreate|CFile::modeWrite);

					Part.WriteParameters(&File);

					File.Close();
				}
			}
            
			break;
		case 9:	//"3.  "
			{
//				int iCount, iResponse;
//				UF_UI_chained_points_p_t *Points;
//				UF_CALL(UF_UI_select_point_collection("Fuck you!!!", FALSE, Points, &iCount, &iResponse));
			}
/*			double dPoint[3];
			tag_t Point;
			for(int i=0;i<Part.iEdgesNum;i++)
				if(!Part.Edges[i].bNothing && !Part.Edges[i].bPS)
					for(int j=0;j<Part.Edges[i].iSectionsNum;j++)
					{
						Part.Edges[i].Sections[j].CalcPoints.PointBevel.Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &Point));
						Part.Edges[i].Sections[j].CalcPoints.PointRounding.Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &Point));
					}*/

			//Demo
			/*{
				PartTag = UF_PART_ask_display_part();

				tag_t Base;
				int iNumber = 0;
				CString string;

				UF_PART_set_display_part(PartTag);

				Base = Part.CreateBase();
				UF_CALL(UF_OBJ_set_color(Base, UF_OBJ_AQUAMARINE));
				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchBase(&Base, Part.CalcMinBaseHeight(), Part.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInBase(&Base, Part.dBaseNormal);
			}*/
			//Work
/*			{
				CFileDialog FD(TRUE, "prt", "", OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST, "Unigraphics files (*.prt)|*.prt|All Files (*.*)|*.*||");
				tag_t UGPart, Base, Press, Bush, Instance;
				int iNumber = 0;
				CString string;
  double origin[3] = {0.0, 0.0, 0.0};
  double csys[6] = {1.0, 0.0, 0.0, 
                    0.0, 1.0, 0.0};
    UF_PART_load_status_t   error_code ;

				if(FD.DoModal()==IDOK)
				{
					Part.AskParametersInteractive();

					if(UF_PART_new((FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Base.prt").GetBuffer(), 1, &UGPart)==-4)
					{
						if(!DeleteFile(FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Base.prt"))
						{
							MessageBox(NULL, "  ", "", MB_OK|MB_ICONEXCLAMATION);
							break;
						}
						else
							UF_PART_new((FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Base.prt").GetBuffer(), 1, &UGPart);
					}
					Base = Part.CreateBase();
					for(int i=0;i<Part.iPunchesNum;i++)
						Part.Punches[i].CreatePunchBase(&Base, Part.CalcMinBaseHeight(), Part.dBaseNormal);
					for(int i=0;i<Part.iPressInsNum;i++)
						Part.PressIns[i].CreatePressInBase(&Base, Part.dBaseNormal);

					UF_CALL(UF_PART_save());
					UF_CALL(UF_PART_close(UGPart, 0, 1));

					//  
//					string.Format("Press %d", iNumber);
//					while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
//						string.Format("Press %d", ++iNumber);

					if(UF_PART_new((FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Press.prt").GetBuffer(), 1, &UGPart)==-4)
					{
						if(!DeleteFile(FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Press.prt"))
						{
							MessageBox(NULL, "  ", "", MB_OK|MB_ICONEXCLAMATION);
							break;
						}
						else
							UF_PART_new((FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Press.prt").GetBuffer(), 1, &UGPart);
					}

					Press = Part.CreatePress1();

					for(int i=0;i<Part.iPunchesNum;i++)
						Part.Punches[i].CreatePunchPress(&Press, Part.dBaseNormal);
					for(int i=0;i<Part.iPressInsNum;i++)
						Part.PressIns[i].CreatePressInPress(&Press, Part.dBaseNormal, Part.t);

					UF_CALL(UF_PART_save());
					UF_CALL(UF_PART_close(UGPart, 0, 1));

					for(int i=0;i<Part.iPressInsNum;i++)
					{
						//Create components
						//  
						string.Format("%s Bush %d.prt", FD.GetPathName().Left(FD.GetPathName().GetLength()-4), i+1);
						if(UF_PART_new(string.GetBuffer(), 1, &UGPart)==-4)
						{
							if(!DeleteFile(string))
							{
								MessageBox(NULL, "  ", "", MB_OK|MB_ICONEXCLAMATION);
								break;
							}
							else
								UF_PART_new(string.GetBuffer(), 1, &UGPart);
						}

						Bush = Part.PressIns[i].CreatePressInBush(Part.dBaseNormal, Part.t);

						UF_CALL(UF_PART_save());
						UF_CALL(UF_PART_close(UGPart, 0, 1));
					}

					// -
					if(UF_PART_new(FD.GetPathName().GetBuffer(), 1, &UGPart)==-4)
					{
						if(!DeleteFile(FD.GetFileName()))
						{
							MessageBox(NULL, "  ", "", MB_OK|MB_ICONEXCLAMATION);
							break;
						}
						else
							UF_PART_new(FD.GetPathName().GetBuffer(), 1, &UGPart);
					}
					
					//  -  
					UF_CALL(UF_ASSEM_add_part_to_assembly(UGPart, (FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Base.prt").GetBuffer(), NULL, NULL, origin, csys, -1, &Instance, &error_code));
					UF_CALL(UF_ASSEM_add_part_to_assembly(UGPart, (FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Press.prt").GetBuffer(), NULL, NULL, origin, csys, -1, &Instance, &error_code));
					for(int i=0;i<Part.iPressInsNum;i++)
					{
						string.Format("%s Bush %d.prt", FD.GetPathName().Left(FD.GetPathName().GetLength()-4), i+1);
						UF_CALL(UF_ASSEM_add_part_to_assembly(UGPart, string.GetBuffer(), NULL, NULL, origin, csys, -1, &Instance, &error_code));
					}
					UF_CALL(UF_PART_save());
				}*/
				/*{
					Part.AskParametersInteractive();

					//  
//					string.Format("Base %d", iNumber);
//					while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
//						string.Format("Base %d", ++iNumber);
					if(UF_PART_new(FD.GetPathName().GetBuffer(), 1, &UGPart)==-4)
					{
						if(!DeleteFile(FD.GetFileName()))
						{
							MessageBox(NULL, "  ", "", MB_OK|MB_ICONEXCLAMATION);
							break;
						}
						else
							UF_PART_new(FD.GetPathName().GetBuffer(), 1, &UGPart);
					}


					Base = Part.CreateBase();
					for(int i=0;i<Part.iPunchesNum;i++)
						Part.Punches[i].CreatePunchBase(&Base, Part.CalcMinBaseHeight(), Part.dBaseNormal);
					for(int i=0;i<Part.iPressInsNum;i++)
						Part.PressIns[i].CreatePressInBase(&Base, Part.dBaseNormal);

					//  
//					string.Format("Press %d", iNumber);
//					while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
//						string.Format("Press %d", ++iNumber);

					Press = Part.CreatePress1();

//					for(int i=0;i<Part.iPunchesNum;i++)
//						Part.Punches[i].CreatePunchPress(&Press, Part.dBaseNormal);
//					for(int i=0;i<Part.iPressInsNum;i++)
//						Part.PressIns[i].CreatePressInPress(&Press, Part.dBaseNormal, Part.t);

/*					for(int i=0;i<Part.iPressInsNum;i++)
					{
						//  
//						string.Format("Bush %d", iNumber);
//						while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
//							string.Format("Bush %d", ++iNumber);
						Bush = Part.PressIns[i].CreatePressInBush(Part.dBaseNormal, Part.t);
						//Create components
						string.Format("%s Bush %d.prt", FD.GetPathName().Left(FD.GetPathName().GetLength()-4), i);
						UF_CALL(UF_ASSEM_create_component_part(UGPart, string.GetBuffer(), NULL, NULL, 1, -1, origin, csys, 1, &Bush, &Instance));
					}

					//Create components
					UF_CALL(UF_ASSEM_create_component_part(UGPart, (FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Base.prt").GetBuffer(), NULL, NULL, 1, -1, origin, csys, 1, &Base, &Instance));
					UF_CALL(UF_ASSEM_create_component_part(UGPart, (FD.GetPathName().Left(FD.GetPathName().GetLength()-4) + " Press.prt").GetBuffer(), NULL, NULL, 1, -1, origin, csys, 1, &Press, &Instance));

					UF_CALL(UF_PART_save());
				}
			}*/
			{
				PartTag = UF_PART_ask_display_part();

				tag_t Base, Press, Bush, Instance;
				int iNumber = 0;
				CString string, sMain;
				char cMain[MAX_FSPEC_SIZE+1];

  double origin[3] = {0.0, 0.0, 0.0};
  double csys[6] = {1.0, 0.0, 0.0, 
                    0.0, 1.0, 0.0};

/*
//				11.0213.K000.213
				Part.Edges[1].bIgnore = true;
				Part.Edges[2].bIgnore = true;
				Part.Edges[3].bIgnore = true;
				Part.Edges[7].bIgnore = true;
				Part.Edges[8].bIgnore = true;
				Part.Edges[9].bIgnore = true;
				Part.Edges[13].bIgnore = true;
				Part.Edges[14].bIgnore = true;
				Part.Edges[15].bIgnore = true;
				Part.Edges[17].bIgnore = true;
				Part.Edges[18].bIgnore = true;
				Part.Edges[19].bIgnore = true;
				Part.Edges[28].bIgnore = true;
				Part.Edges[29].bIgnore = true;
				Part.Edges[30].bIgnore = true;
				Part.Edges[31].bIgnore = true;
				Part.Edges[32].bIgnore = true;
				Part.Edges[33].bIgnore = true;
				Part.Edges[34].bIgnore = true;

				Part.Edges[21].dOffset = -10;
				Part.Edges[22].dOffset = -15;
				Part.Edges[23].dOffset = -15;
				Part.Edges[24].dOffset = -15;
				Part.Edges[25].dOffset = -15;
				Part.Edges[26].dOffset = -15;
				Part.Edges[27].dOffset = -15;
				Part.Edges[35].dOffset = -15;
				Part.Edges[36].dOffset = -15;
				Part.Edges[37].dOffset = -15;
*/
				Part.AskParametersInteractive();

				UF_PART_set_display_part(PartTag);
				UF_CALL(UF_PART_ask_part_name(PartTag, sMain.GetBuffer(MAX_FSPEC_SIZE+1)));
				sMain.ReleaseBuffer();
				sMain = sMain.Left(sMain.ReverseFind('\\')+1);

				Base = Part.CreateBase();
				UF_CALL(UF_OBJ_set_color(Base, UF_OBJ_AQUAMARINE));
				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchBase(&Base, Part.CalcMinBaseHeight(), Part.Service.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInBase(&Base, Part.Service.dBaseNormal);


				iNumber = 0;
				string.Format("Base%d", iNumber);
				string = sMain + string;
				while(UF_PART_ask_part_tag(string.GetBuffer()) != NULL_TAG)
				{
					iNumber++;
					string.Format("Base%d", iNumber);
					string = sMain + string;
				}
				UF_CALL(UF_ASSEM_create_component_part(PartTag, string.GetBuffer(), NULL, NULL, 1, -1, origin, csys, 1, &Base, &Instance));
				string.ReleaseBuffer();

				dG_BasePressDistance += Part.t;
				Press = Part.CreatePress1();
				UF_CALL(UF_OBJ_set_color(Press, UF_OBJ_OLIVE));
				for(int i=0;i<Part.iPunchesNum;i++)
					Part.Punches[i].CreatePunchPress(&Press, Part.Service.dBaseNormal);
				for(int i=0;i<Part.iPressInsNum;i++)
					Part.PressIns[i].CreatePressInPress(&Press, Part.Service.dBaseNormal, Part.t);
				dG_BasePressDistance -= Part.t;

				iNumber = 0;
				string.Format("Press%d", iNumber);
				string = sMain + string;
				while(UF_PART_ask_part_tag(string.GetBuffer()) != NULL_TAG)
				{
					iNumber++;
					string.Format("Press%d", iNumber);
					string = sMain + string;
				}
				UF_CALL(UF_ASSEM_create_component_part(PartTag, string.GetBuffer(), NULL, NULL, 1, -1, origin, csys, 1, &Press, &Instance));
				string.ReleaseBuffer();

				for(int i=0;i<Part.iPressInsNum;i++)
				{
					Bush = Part.PressIns[i].CreatePressInBush(Part.Service.dBaseNormal, Part.t);
					UF_CALL(UF_OBJ_set_color(Bush, UF_OBJ_CYAN));

					iNumber = 0;
					string.Format("Bush%d", iNumber);
					string = sMain + string;
					while(UF_PART_ask_part_tag(string.GetBuffer()) != NULL_TAG)
					{
						iNumber++;
						string.Format("Bush%d", iNumber);
						string = sMain + string;
					}
					UF_CALL(UF_ASSEM_create_component_part(PartTag, string.GetBuffer(), NULL, NULL, 1, -1, origin, csys, 1, &Bush, &Instance));
					string.ReleaseBuffer();
				}
			}
			break;
		case 10:	//"4.  "
			{
				tag_t UGPart, Involute, PartTag;
				int iNumber = 0;
				CString string;

				PartTag = UF_PART_ask_display_part();

				//  
				string.Format("Involute %d", iNumber);
				while(UF_PART_new(string.GetBuffer(), 1, &UGPart))
					string.Format("Involute %d", ++iNumber);

				Involute = Part.CreateInvolute();

				UF_PART_set_display_part(PartTag);
			}
			break;
		case 11:	//" "

/*			{
				double dPoint[3];
				for(int i=0;i<Part.iEdgesNum;i++)
					for(int j=0;j<Part.Edges[i].iSectionsNum;j++)
					{
						Part.Edges[i].Sections[j].PointRounding.Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &PartTag));
						Part.Edges[i].Sections[j].PointBevel.Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &PartTag));
					}
					break;
			}*/

/*			{
				double dPoint[3];
				for(int i=0;i<Part.iPressEdgesNum;i++)
					for(int j=0;j<Part.iPressPointsNum[i];j++)
					{
						Part.PointsPress[i][j].Fill(dPoint);
						UF_CALL(UF_CURVE_create_point(dPoint, &PartTag));
					}
					break;
			}*/

//			DlgSettings.m_DistTol = dG_DistTol;
//			DlgSettings.m_InnerCoef = dG_InnerCoef;
			if(DlgSettings.DoModal()==IDOK)
			{
				dG_DistTol = DlgSettings.m_DistTol;
				dG_InnerCoef = DlgSettings.m_InnerCoef;
				iSplinesDegree = DlgSettings.m_SplinesDegree;
				dG_BaseAdditionalThickness = DlgSettings.m_AdditionalThickness;
				bG_SingleRadius = DlgSettings.m_SingleRadius;
				dG_PressThickness = DlgSettings.m_PressThickness;
				dG_BushInPressThickness = DlgSettings.m_BushInPressThickness;
				dG_RoundingsRadius = DlgSettings.m_RoundingsRadius;
			}
			break;
		}
	}

	return 0;
}

// 
void ufusr(char *param, int *retcode, int param_len)
{
	if(UF_CALL(!UF_initialize()))
	{
		Main();
		UF_terminate();
	}
}

int ufusr_ask_unload(void)
{
	return UF_UNLOAD_IMMEDIATELY;
}