#include "StdAfx.h"
#include "Classes.h"
#include "Utilities.h"

//     
//  ,     
// :
//1 -      , ,  
//2 -        , ,    
int FindSignificantFaces(
	tag_t SheetBody,
	tag_t *FaceBase,
	uf_list_p_t *FacesRounding,
	uf_list_p_t *FacesBevel,
	uf_list_p_t *FacesUndercutRounding,
	uf_list_p_t *FacesUndercut,
	uf_list_p_t *FacesPunchRounding,
	uf_list_p_t *FacesPunchBevel,
	uf_list_p_t *FacesPressInRounding1,
	uf_list_p_t *FacesPressInBevel,
	uf_list_p_t *FacesPressInRounding2,
	uf_list_p_t *FacesPressInBottom)
{
uf_list_p_t Faces;
tag_t Face;
int iNumber1, iNumber2;

	UF_CALL(UF_MODL_ask_body_faces(SheetBody, &Faces));

	//   -      
	if(FindBaseFaces(SheetBody, FaceBase)==1)
		return 1;

	//   -  ,      
	//     ,      
	if(FindOuterInnerFaces(*FaceBase, FacesRounding, FacesPunchRounding)==1)
		return 2;

	//  .  ,     ( ),    
	UF_CALL(UF_MODL_ask_list_count(*FacesRounding, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesRounding, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesBevel, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesBevel, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_delete_list_item(FacesBevel, *FaceBase));
		UF_CALL(UF_MODL_ask_list_count(*FacesRounding, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesRounding, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesBevel, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesBevel, Face));
		}
	}

	//   .  ,    ,    
	//(     )
	UF_CALL(UF_MODL_ask_list_count(*FacesBevel, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesBevel, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesUndercutRounding, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesUndercutRounding, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_ask_list_count(*FacesBevel, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesBevel, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesUndercutRounding, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesUndercutRounding, Face));
		}
		UF_CALL(UF_MODL_ask_list_count(*FacesRounding, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesRounding, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesUndercutRounding, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesUndercutRounding, Face));
		}
	}

	//  .  ,     ,    
	//(     )
	UF_CALL(UF_MODL_ask_list_count(*FacesUndercutRounding, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesUndercutRounding, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesUndercut, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesUndercut, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_ask_list_count(*FacesUndercut, &iNumber2));
		if(iNumber2)
		{
			UF_CALL(UF_MODL_ask_list_count(*FacesUndercutRounding, &iNumber1));
			for(int i=0;i<iNumber1;i++)
			{
				UF_CALL(UF_MODL_ask_list_item(*FacesUndercutRounding, i, &Face));
				UF_CALL(UF_MODL_put_list_item(*FacesUndercut, Face));
				UF_CALL(UF_MODL_delete_list_item(FacesUndercut, Face));
			}
			UF_CALL(UF_MODL_ask_list_count(*FacesBevel, &iNumber1));
			for(int i=0;i<iNumber1;i++)
			{
				UF_CALL(UF_MODL_ask_list_item(*FacesBevel, i, &Face));
				UF_CALL(UF_MODL_put_list_item(*FacesUndercut, Face));
				UF_CALL(UF_MODL_delete_list_item(FacesUndercut, Face));
			}
		}
	}

	//     .  ,        ( ),    
	UF_CALL(UF_MODL_ask_list_count(*FacesPunchRounding, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesPunchRounding, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPunchBevel, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesPunchBevel, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_delete_list_item(FacesPunchBevel, *FaceBase));
		UF_CALL(UF_MODL_ask_list_count(*FacesPunchRounding, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPunchRounding, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPunchBevel, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPunchBevel, Face));
		}
	}

	//    .  ,     ,    
	//(       - )
	UF_CALL(UF_MODL_ask_list_count(*FacesPunchBevel, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesPunchBevel, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInRounding2, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding2, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_ask_list_count(*FacesPunchBevel, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPunchBevel, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInRounding2, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInRounding2, Face));
		}
		UF_CALL(UF_MODL_ask_list_count(*FacesPunchRounding, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPunchRounding, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInRounding2, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInRounding2, Face));
		}
	}

	//   .  ,      ,    
	//(       - )
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding2, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesPressInRounding2, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInBottom, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInBottom, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding2, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInRounding2, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInBottom, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInBottom, Face));
		}
		UF_CALL(UF_MODL_ask_list_count(*FacesPunchBevel, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPunchBevel, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInBottom, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInBottom, Face));
		}
	}

	//,       (    ),
	//        
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding2, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesPressInRounding2, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInBevel, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInBevel, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding2, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInRounding2, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInBevel, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInBevel, Face));
		}
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInBottom, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInBottom, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInBevel, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInBevel, Face));
		}
		//        
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInBevel, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInBevel, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPunchBevel, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPunchBevel, Face));
		}
	}

	//,      (     ),
	//        
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInBevel, &iNumber1));
	for(int i=0;i<iNumber1;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*FacesPressInBevel, i, &Face));
		UF_CALL(UF_MODL_create_list(&Faces));
		UF_CALL(UF_MODL_ask_adjac_faces(Face, &Faces));

		UF_CALL(UF_MODL_ask_list_count(Faces, &iNumber2));
		for(int j=0;j<iNumber2;j++)
		{
			UF_CALL(UF_MODL_ask_list_item(Faces, j, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInRounding1, Face));
		}

		UF_CALL(UF_MODL_delete_list(&Faces));
	}
	//  
	UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding1, &iNumber2));
	if(iNumber2)
	{
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInBevel, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInBevel, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInRounding1, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInRounding1, Face));
		}
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding2, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInRounding2, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPressInRounding1, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPressInRounding1, Face));
		}
		//        
		UF_CALL(UF_MODL_ask_list_count(*FacesPressInRounding1, &iNumber1));
		for(int i=0;i<iNumber1;i++)
		{
			UF_CALL(UF_MODL_ask_list_item(*FacesPressInRounding1, i, &Face));
			UF_CALL(UF_MODL_put_list_item(*FacesPunchRounding, Face));
			UF_CALL(UF_MODL_delete_list_item(FacesPunchRounding, Face));
		}
	}

	return 0;
}

//     -  
// :           .
// :
//1 -     
int FindBaseFaces(tag_t SheetBody, tag_t *Base)
{
uf_list_p_t Faces, TempFeatures;
tag_t Face, LinkedFeature, LinkedBody;
int iFaces;
int iMajorFace=-1;
double dMajorArea=-1;
int iType, iNorm_dir;
double dPoint[3], dDir[3], dBox[6], dRadius, dRad_data;
double dAcc_value[11], dMass_props[47], dStatistics[13];

	dAcc_value[0] = .9999;

	UF_CALL(UF_MODL_create_list(&Faces));
	UF_CALL(UF_MODL_create_list(&TempFeatures));

	UF_CALL(UF_MODL_ask_body_faces(SheetBody, &Faces));
	UF_CALL(UF_MODL_ask_list_count(Faces, &iFaces));

	for(int i=0;i<iFaces;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(Faces, i, &Face));
        
		UF_CALL(UF_MODL_ask_face_data(
			Face,
			&iType,
			dPoint,
			dDir,
			dBox,
			&dRadius,
			&dRad_data,
			&iNorm_dir));

		//  
		if(iType==22)
		{
			//   ,   
			UF_CALL(UF_WAVE_create_linked_face(Face, NULL_TAG, UF_ASSEM_ask_work_part(), true, &LinkedFeature));
			UF_CALL(UF_MODL_put_list_item(TempFeatures, LinkedFeature));
			UF_CALL(UF_MODL_ask_feat_body(LinkedFeature, &LinkedBody));

			// 
			UF_CALL(UF_MODL_ask_mass_props_3d(
				&LinkedBody,
				1,
				2,
				3,
				1,
				1,
				dAcc_value,
				dMass_props,
				dStatistics));

			if(dMass_props[0]>dMajorArea)
			{
				dMajorArea = dMass_props[0];
				iMajorFace = i;
				*Base = Face;
			}
		}
	}

	//  
	UF_CALL(UF_MODL_delete_feature(TempFeatures));

	UF_CALL(UF_MODL_delete_list(&Faces));
	UF_CALL(UF_MODL_create_list(&TempFeatures));

	if(iMajorFace==-1)
	{
		*Base = NULL_TAG;
		return 1;
	}
	else
	    return 0;
}

//,   ,    
// :
//1 -    
int GetOuterEdges(tag_t Face, uf_list_p_t *Edges)
{
uf_loop_p_t Loops;
uf_list_p_t TempEdges;
int iLoops, iType;

	UF_CALL(UF_MODL_ask_face_loops(Face, &Loops));
	UF_CALL(UF_MODL_ask_loop_list_count(Loops, &iLoops));

	for(int i=0;i<iLoops;i++)
	{
		UF_CALL(UF_MODL_create_list(&TempEdges));

		UF_CALL(UF_MODL_ask_loop_list_item(Loops, i, &iType, &TempEdges));

		if(iType==1)
		{
			UF_CALL(UF_MODL_ask_loop_list_item(Loops, i, &iType, Edges));
			return 0;
		}
		UF_CALL(UF_MODL_delete_list(&TempEdges));
	}
	return 1;
}

//,   
// ,   ,      
// :
//1 -       , ,  
int FindOuterInnerFaces(tag_t Face, uf_list_p_t *OuterAdjFaces, uf_list_p_t *InnerAdjFaces)
{
uf_list_p_t EdgesBaseOuter, SharedEdges;
tag_t FaceTemp, EdgeTemp;
int iNumber, iNumberTemp1, iNumberTemp2;

	UF_CALL(UF_MODL_create_list(&EdgesBaseOuter));
	if(GetOuterEdges(Face, &EdgesBaseOuter)==1)
		return 1;

	//   Face 
	UF_CALL(UF_MODL_ask_adjac_faces(Face, OuterAdjFaces));
	UF_CALL(UF_MODL_ask_list_count(*OuterAdjFaces, &iNumber));
	for(int i=0;i<iNumber;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(*OuterAdjFaces, i, &FaceTemp));

		if(FaceTemp==NULL_TAG)
		{
			UF_CALL(UF_MODL_delete_list_item(OuterAdjFaces, FaceTemp));
			iNumber--;
			i--;
			continue;
		}

		// ,       
		//        ( )      Face
		//(    FaceTemp      ,     Face)
		UF_CALL(UF_MODL_create_list(&SharedEdges));
		UF_CALL(UF_MODL_ask_shared_edges(Face, FaceTemp, &SharedEdges));
		UF_CALL(UF_MODL_ask_list_item(SharedEdges, 0, &EdgeTemp));

		// EdgeTemp     EdgesBaseOuter
		UF_CALL(UF_MODL_ask_list_count(EdgesBaseOuter, &iNumberTemp1));
		UF_CALL(UF_MODL_put_list_item(EdgesBaseOuter, EdgeTemp));
		UF_CALL(UF_MODL_ask_list_count(EdgesBaseOuter, &iNumberTemp2));
		if(iNumberTemp1!=iNumberTemp2)	// EdgeTemp    EdgesBaseOuter
		{
			UF_CALL(UF_MODL_delete_list_item(&EdgesBaseOuter, EdgeTemp));
			UF_CALL(UF_MODL_put_list_item(*InnerAdjFaces, FaceTemp));
			UF_CALL(UF_MODL_delete_list_item(OuterAdjFaces, FaceTemp));
			iNumber--;
			i--;
		}
		
		UF_CALL(UF_MODL_delete_list(&SharedEdges));
	}

	UF_CALL(UF_MODL_delete_list(&EdgesBaseOuter));

	return 0;
}

//      
// :
//1 -      
int ScanSectionParms(
	tag_t Plane,			// 
	uf_list_p_t FacesBevel,	// "" 
	double dPoint[3],		// 
	double *dSectionPoint,	//  
	double *dRadius,		//  
	double *dDistance)		//  
{
UF_MODL_intersect_info_p_t **Intersections;
tag_t Face;
int iNumber, *iIntNum, iMaxI=-1, iMaxJ=-1, iFlag=UF_MODL_LOC, iTemp;
double dDist, daTemp[3], dMinDist=1e100, dMaxDist=-1e100, dP0=0, dP1=1, dPoint0[3], dPoint1[3], dDist0, dDist1, dCurveRange[2]={0,1}, dCurva[5];

	//  
	UF_CALL(UF_MODL_ask_list_count(FacesBevel, &iNumber));
	Intersections = new UF_MODL_intersect_info_p_t*[iNumber];
	iIntNum = new int[iNumber];
	for(int i=0;i<iNumber;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(FacesBevel, i, &Face));
		UF_CALL(UF_MODL_intersect_objects(Plane, Face, 1e-5, &iIntNum[i], &Intersections[i]));
	}

	//  
	/*for(int i=0;i<iNumber;i++)
	for(int j=0;j<iIntNum[i];j++)
	{
		if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_CURVE)
		{
			UF_CALL(UF_MODL_ask_minimum_dist(
				Intersections[i][j]->intersect.curve.identifier,
				NULL_TAG,
				0,
				daTemp,
				1,
				dPoint,
				&dDist,
				daTemp,
				daTemp));
		}
		else if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_POINT)
		{
			UF_CALL(UF_MODL_ask_minimum_dist(
				NULL_TAG,
				NULL_TAG,
				1,
				Intersections[i][j]->intersect.point.coords,
				1,
				dPoint,
				&dDist,
				daTemp,
				daTemp));
		}
		if(dDist<dMinDist)
			dMinDist = dDist;
	}*/

	dMinDist = dG_DistTol;

	//  ,        
	//    ,       
	for(int i=0;i<iNumber;i++)
	for(int j=0;j<iIntNum[i];j++)
	{
		if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_CURVE)
		{
			UF_CALL(UF_MODL_ask_minimum_dist(
				Intersections[i][j]->intersect.curve.identifier,
				NULL_TAG,
				0,
				daTemp,
				1,
				dPoint,
				&dDist,
				daTemp,
				daTemp));
		}
		else if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_POINT)
		{
			UF_CALL(UF_MODL_ask_minimum_dist(
				NULL_TAG,
				NULL_TAG,
				1,
				Intersections[i][j]->intersect.point.coords,
				1,
				dPoint,
				&dDist,
				daTemp,
				daTemp));
		}
		if(dDist<=dMinDist)
		{
			if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_CURVE)
			{
				UF_CALL(UF_MODL_evaluate_curve(Intersections[i][j]->intersect.curve.identifier, &dP0, &iFlag, dPoint0));
				UF_CALL(UF_MODL_ask_minimum_dist(
					NULL_TAG,
					NULL_TAG,
					1,
					dPoint0,
					1,
					dPoint,
					&dDist0,
					daTemp,
					daTemp));

				UF_CALL(UF_MODL_evaluate_curve(Intersections[i][j]->intersect.curve.identifier, &dP1, &iFlag, dPoint1));
				UF_CALL(UF_MODL_ask_minimum_dist(
					NULL_TAG,
					NULL_TAG,
					1,
					dPoint1,
					1,
					dPoint,
					&dDist1,
					daTemp,
					daTemp));
				if(dDist0>dDist1)
					dDist = dDist0;
				else
					dDist = dDist1;
			}
			if(dDist>dMaxDist)
			{
				dMaxDist = dDist;
				iMaxI = i;
				iMaxJ = j;
			}
		}
	}

	if(iMaxI==-1)
	{
		//  
		for(int i=0;i<iNumber;i++)
		for(int j=0;j<iIntNum[i];j++)
		{
			if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_CURVE)
				UF_CALL(UF_ASSEM_remove_instance(Intersections[i][j]->intersect.curve.identifier));
			else if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_COINCIDE)
				UF_CALL(UF_ASSEM_remove_instance(Intersections[i][j]->intersect.coincide.identifier));
			UF_free(Intersections[i][j]);
		}
		delete [] Intersections;

		return 1;
	}

	//          ,     dPoint
	if(Intersections[iMaxI][iMaxJ]->intersect_type==UF_MODL_INTERSECT_CURVE)
	{
		UF_CALL(UF_MODL_evaluate_curve(Intersections[iMaxI][iMaxJ]->intersect.curve.identifier, &dP0, &iFlag, dPoint0));
		UF_CALL(UF_MODL_ask_minimum_dist(
			NULL_TAG,
			NULL_TAG,
			1,
			dPoint0,
			1,
			dPoint,
			&dDist0,
			daTemp,
			daTemp));

		UF_CALL(UF_MODL_evaluate_curve(Intersections[iMaxI][iMaxJ]->intersect.curve.identifier, &dP1, &iFlag, dPoint1));
		UF_CALL(UF_MODL_ask_minimum_dist(
			NULL_TAG,
			NULL_TAG,
			1,
			dPoint1,
			1,
			dPoint,
			&dDist1,
			daTemp,
			daTemp));
		if(dDist0>dDist1)
		{
			dSectionPoint[0] = dPoint0[0];
			dSectionPoint[1] = dPoint0[1];
			dSectionPoint[2] = dPoint0[2];
		}
		else
		{
			dSectionPoint[0] = dPoint1[0];
			dSectionPoint[1] = dPoint1[1];
			dSectionPoint[2] = dPoint1[2];
		}
	}
	else if(Intersections[iMaxI][iMaxJ]->intersect_type==UF_MODL_INTERSECT_POINT)
	{
		dSectionPoint[0] = Intersections[iMaxI][iMaxJ]->intersect.point.coords[0];
		dSectionPoint[1] = Intersections[iMaxI][iMaxJ]->intersect.point.coords[1];
		dSectionPoint[2] = Intersections[iMaxI][iMaxJ]->intersect.point.coords[2];
	}

	//   
	if(dDistance!=NULL)
		*dDistance = sqrt((dPoint[0]-dSectionPoint[0])*(dPoint[0]-dSectionPoint[0]) + (dPoint[1]-dSectionPoint[1])*(dPoint[1]-dSectionPoint[1]) + (dPoint[2]-dSectionPoint[2])*(dPoint[2]-dSectionPoint[2]));

	//   
	if(dRadius!=NULL)
	{
		if(Intersections[iMaxI][iMaxJ]->intersect_type==UF_MODL_INTERSECT_CURVE)
		{
			UF_CALL(UF_MODL_ask_max_curvature(Intersections[iMaxI][iMaxJ]->intersect.curve.identifier, dCurveRange, 0, dCurva, &iTemp));
			*dRadius = 1/dCurva[4];
		}
		else if(Intersections[iMaxI][iMaxJ]->intersect_type==UF_MODL_INTERSECT_POINT)
			*dRadius = 0;
	}

	//  
	for(int i=0;i<iNumber;i++)
	for(int j=0;j<iIntNum[i];j++)
	{
		if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_CURVE)
			UF_CALL(UF_ASSEM_remove_instance(Intersections[i][j]->intersect.curve.identifier));
		else if(Intersections[i][j]->intersect_type==UF_MODL_INTERSECT_COINCIDE)
			UF_CALL(UF_ASSEM_remove_instance(Intersections[i][j]->intersect.coincide.identifier));
		UF_free(Intersections[i][j]);
	}
	delete [] Intersections;

	return 0;
}

//     ,    
double CalcR(CPoint3D P1, CPoint3D P2, CPoint3D P3, bool *bNoCircle)
{
double xc, yc, x1=P1.X, y1=P1.Y, z1=P1.Z, x2=P2.X, y2=P2.Y, z2=P2.Z, x3=P3.X, y3=P3.Y, z3=P3.Z;
double D = 2*(-y1*x3 + y1*x2 - x1*y2 + x1*y3 - x2*y3 + y2*x3);

	if(D==0)
	{
		*bNoCircle = true;
		return 0;
	}

	*bNoCircle = false;
	xc = (y3*y1*y1 - y2*y2*y3 - y2*y1*y1 - x2*x2*y3 + y2*x3*x3 + x2*x2*y1 - x3*x3*y1 + y2*y2*y1 - y2*x1*x1 - y3*y3*y1 + y3*x1*x1 + y2*y3*y3)/D;
	yc = -(x2*x2*x1 + y2*y2*x1 - x3*x3*x1 - y3*y3*x1 - x1*x1*x2 + x1*x1*x3 - y1*y1*x2 + y1*y1*x3 + x3*x3*x2 + y3*y3*x2 - x2*x2*x3 - y2*y2*x3)/D;

	return sqrt((xc-x1)*(xc-x1) + (yc-y1)*(yc-y1));
}

//,    
double CalcAngle(CPoint3D V1, CPoint3D V2)
{
double D = sqrt(V1.X*V1.X+V1.Y*V1.Y+V1.Z*V1.Z)*sqrt(V2.X*V2.X+V2.Y*V2.Y+V2.Z*V2.Z);
	
	if(D==0)
		return 500+PI/2;
	else
		return acos((V1.X*V2.X+V1.Y*V2.Y+V1.Z*V2.Z)/D);
}

//  
double Gamma
(
	double K,
	double n,
	double t,
	double h,
	double R,
	double r,
	double Alpha,
	double E
)
{
	double Beta = Alpha;
	Alpha = PI/2 - Beta;
	double A,B;

/*	if(R>100)
	{
		double BA = t*t/(4*r*Alpha);
		double BB = (h*h*h*(1-sin(Beta))/(R*R));
		double BC = (1-3*h/(8*R));
		double B = (2+n)*E*(t*t/(4*r*Alpha) + (h*h*h*(1-sin(Beta))/(R*R))*(1-3*h/(8*R)));
		double A = 3*K*(pow(t,1+n)/(pow(2,1+n)*pow(r,n)) + (pow(h,2+n)*pow(1-sin(Beta),n)/pow(R, 1+n)) * (1 + (.5-n)*(2+n)*h/((3+n)*R)));
		double C = 3*K*(pow(t,1+n)/(pow(2,1+n)*pow(r,n)) + (pow(h,2+n)*pow(1-sin(Beta),n)/pow(R, 1+n)) * (1 + (.5-n)*(2+n)*h/((3+n)*R))) / (2+n)*E*(t*t/(4*r*Alpha) + (h*h*h*(1-sin(Beta))/(R*R))*(1-3*h/(8*R)));
		double Z=15;
	}*/
	if(R>0)
	{
		A = 3*K*(pow(t,1+n)/(pow(2,1+n)*pow(r,n)) + (pow(h,2+n)*pow(1-sin(Beta),n)/pow(R, 1+n)) * (1 + (.5-n)*(2+n)*h/((3+n)*R)));
		B = (2+n)*E*(t*t/(4*r*Alpha) + (h*h*h*(1-sin(Beta))/(R*R))*(1-3*h/(8*R)));
		return A/B;
	}
//		return 3*K*(pow(t,1+n)/(pow(2,1+n)*pow(r,n)) + (pow(h,2+n)*pow(1-sin(Beta),n)/pow(R, 1+n)) * (1 + (.5-n)*(2+n)*h/((3+n)*R))) / (2+n)*E*(t*t/(4*r*Alpha) + (h*h*h*(1-sin(Beta))/(R*R))*(1-3*h/(8*R)));
	else if(R<0)
	{
		A = 3*K*(pow(t,1+n)/(pow(2,1+n)*pow(r,n)) + (pow(h,2+n)*pow(1-sin(Beta),n)/pow(-R, 1+n)) * (1 + (.5-n)*(2+n)*h/((3+n)*R)));
		B = (2+n)*E*(t*t/(4*r*Alpha) + (h*h*h*(1-sin(Beta))/(R*R))*(1-3*h/(8*R)));
		return A/B;
	}
//		return 3*K*(pow(t,1+n)/(pow(2,1+n)*pow(r,n)) + (pow(h,2+n)*pow(1-sin(Beta),n)/pow(-R, 1+n)) * (1 + (.5-n)*(2+n)*h/((3+n)*R))) / (2+n)*E*(t*t/(4*r*Alpha) + (h*h*h*(1-sin(Beta))/(R*R))*(1-3*h/(8*R)));
	else if(R==0)
	{
//		MessageBox(NULL, "R=0", "Error", MB_OK);

		A = 12*K*Alpha*pow(t,1+n);
		B = ((2+n)*E*t*t*pow(2, 1+n)*pow(r, n-1));
		return A/B;
	}
//		return 12*K*Alpha*pow(t,1+n) / ((2+n)*E*t*t*pow(2, 1+n)*pow(r, n-1));
}

//  Point   Axis   dAngle
void Rotate(CPoint3D *Point, CPoint3D Axis, double dAngle)
{
double x,y,z,l;

//
	l = sqrt(Axis.X*Axis.X + Axis.Y*Axis.Y + Axis.Z*Axis.Z);
	Axis.X /= l;
	Axis.Y /= l;
	Axis.Z /= l;

	z = Point->Z * (cos(dAngle) + (1-cos(dAngle))*Axis.Z*Axis.Z) +
		Point->X * ((1-cos(dAngle))*Axis.Z*Axis.X - Axis.Y*sin(dAngle)) +
		Point->Y * ((1-cos(dAngle))*Axis.Z*Axis.Y + Axis.X*sin(dAngle));

	x = Point->Z * ((1-cos(dAngle))*Axis.Z*Axis.X + Axis.Y*sin(dAngle)) +
		Point->X * (cos(dAngle) + (1-cos(dAngle))*Axis.X*Axis.X) +
		Point->Y * ((1-cos(dAngle))*Axis.X*Axis.Y - Axis.Z*sin(dAngle));

	y = Point->Z * ((1-cos(dAngle))*Axis.Z*Axis.Y - Axis.X*sin(dAngle)) +
		Point->X * ((1-cos(dAngle))*Axis.X*Axis.Y + Axis.Z*sin(dAngle)) +
		Point->Y * (cos(dAngle) + (1-cos(dAngle))*Axis.Y*Axis.Y);

	Point->X = x;
	Point->Y = y;
	Point->Z = z;
}
void Rotate(double *dPoint, CPoint3D Axis, double dAngle)
{
double x,y,z,l;
CPoint3D Point;

	Point = dPoint;

//
	l = sqrt(Axis.X*Axis.X + Axis.Y*Axis.Y + Axis.Z*Axis.Z);
	Axis.X /= l;
	Axis.Y /= l;
	Axis.Z /= l;

	z = Point.Z * (cos(dAngle) + (1-cos(dAngle))*Axis.Z*Axis.Z) +
		Point.X * ((1-cos(dAngle))*Axis.Z*Axis.X - Axis.Y*sin(dAngle)) +
		Point.Y * ((1-cos(dAngle))*Axis.Z*Axis.Y + Axis.X*sin(dAngle));

	x = Point.Z * ((1-cos(dAngle))*Axis.Z*Axis.X + Axis.Y*sin(dAngle)) +
		Point.X * (cos(dAngle) + (1-cos(dAngle))*Axis.X*Axis.X) +
		Point.Y * ((1-cos(dAngle))*Axis.X*Axis.Y - Axis.Z*sin(dAngle));

	y = Point.Z * ((1-cos(dAngle))*Axis.Z*Axis.Y - Axis.X*sin(dAngle)) +
		Point.X * ((1-cos(dAngle))*Axis.X*Axis.Y + Axis.Z*sin(dAngle)) +
		Point.Y * (cos(dAngle) + (1-cos(dAngle))*Axis.Y*Axis.Y);

	dPoint[0] = x;
	dPoint[1] = y;
	dPoint[2] = z;
}

//This function calculates angle between two vectors
//Input values:
//Coordinates of the two vectors
double CalcAngle(double *dVector1, double *dVector2)
{
double dD = sqrt(dVector1[0]*dVector1[0]+dVector1[1]*dVector1[1]+dVector1[2]*dVector1[2])*sqrt(dVector2[0]*dVector2[0]+dVector2[1]*dVector2[1]+dVector2[2]*dVector2[2]);
	
	if(dD==0)
		return 0;
	else
		return acos((dVector1[0]*dVector2[0]+dVector1[1]*dVector2[1]+dVector1[2]*dVector2[2])/dD);
}

//This function transforms coordinates of a point to new coordinate system
//Input values:
//Coordinate of the point
//Coordinates of three vectors of new coordinate system
//Offset after transforming
void TransformCoordinateSystem(CPoint3D *Point, double *dX, double *dY, double *dZ, double *dOffset)
{
double dT11, dT21, dT31;
double dT12, dT22, dT32;
double dT13, dT23, dT33;
double dAxis[3], dPoint[3];

	dPoint[0] = Point->X - dOffset[0];
	dPoint[1] = Point->Y - dOffset[1];
	dPoint[2] = Point->Z - dOffset[2];

	//Calculating cone directors
	dAxis[0] = 1;
	dAxis[1] = 0;
	dAxis[2] = 0;
	dT11 = cos(CalcAngle(dX, dAxis));
	dT12 = cos(CalcAngle(dY, dAxis));
	dT13 = cos(CalcAngle(dZ, dAxis));

	dAxis[0] = 0;
	dAxis[1] = 1;
	dAxis[2] = 0;
	dT21 = cos(CalcAngle(dX, dAxis));
	dT22 = cos(CalcAngle(dY, dAxis));
	dT23 = cos(CalcAngle(dZ, dAxis));

	dAxis[0] = 0;
	dAxis[1] = 0;
	dAxis[2] = 1;
	dT31 = cos(CalcAngle(dX, dAxis));
	dT32 = cos(CalcAngle(dY, dAxis));
	dT33 = cos(CalcAngle(dZ, dAxis));

    //Calculating new point coordinates
	dAxis[0] = dT11*dPoint[0] + dT21*dPoint[1] + dT31*dPoint[2];
	dAxis[1] = dT12*dPoint[0] + dT22*dPoint[1] + dT32*dPoint[2];
	dAxis[2] = dT13*dPoint[0] + dT23*dPoint[1] + dT33*dPoint[2];

	Point->X = dAxis[0];// + dOffset[0];
	Point->Y = dAxis[1];// + dOffset[1];
	Point->Z = dAxis[2];// + dOffset[2];
}

//This function creates a point distant from a given point to given distance in given direction
//Input values:
//Cooordinates of the origin point
//Coordinates of calculated point
//Direction vector
//Distance
void OffsetPoint(double *dOrigin, double *dPoint, double *dVector, double dDistance)
{
double l;

	l = sqrt(dVector[0]*dVector[0] + dVector[1]*dVector[1] + dVector[2]*dVector[2]);
	if(l==0)
		return;
	
	dPoint[0] = dOrigin[0] + dVector[0]/l * dDistance;
	dPoint[1] = dOrigin[1] + dVector[1]/l * dDistance;
	dPoint[2] = dOrigin[2] + dVector[2]/l * dDistance;
}

//  /       
// ,   
void ConnectCurves(tag_t Curve1, tag_t Curve2)
{
double dProlongation = 1000, dRefPoint[3]={0,0,0}, dLength;
UF_CURVE_intersect_info_s Intersection;
UF_EVAL_p_t Eval;
double dPar[2];

	UF_CALL(UF_EVAL_initialize(Curve1, &Eval));
	UF_CALL(UF_EVAL_ask_limits(Eval, dPar));
	UF_CALL(UF_EVAL_evaluate(Eval, 0, dPar[1], dRefPoint, NULL));
	UF_CALL(UF_EVAL_free(Eval));

	UF_CALL(UF_CURVE_edit_length(Curve1, 1, dProlongation, 2, UF_CURVE_LINEAR_SHAPE));
	UF_CALL(UF_CURVE_edit_length(Curve2, 1, dProlongation, 1, UF_CURVE_LINEAR_SHAPE));

	UF_CALL(UF_CURVE_intersect(Curve1, Curve2, dRefPoint, &Intersection));

	UF_CALL(UF_CURVE_ask_arc_length(Curve1, 0, Intersection.curve_parm, UF_MODL_MMETER, &dLength));
	UF_CALL(UF_CURVE_edit_length(Curve1, 2, dLength, 2, UF_CURVE_LINEAR_SHAPE));

	UF_CALL(UF_CURVE_ask_arc_length(Curve2, Intersection.entity_parms[0], 1, UF_MODL_MMETER, &dLength));
	UF_CALL(UF_CURVE_edit_length(Curve2, 2, dLength, 1, UF_CURVE_LINEAR_SHAPE));
}

//,    ( )  
//   dG_DistTol
bool CurvesCoincide2(tag_t Curve1, tag_t Curve2, double dTol)
{
double dRef[3] = {0,0,0};
UF_MODL_intersect_info_p_t *Intersections;
int iIntersections;

	if(Curve1==NULL_TAG || Curve2==NULL_TAG)
		return false;

	if(dTol == 0)
		dTol = dG_DistTol;

	UF_CALL(UF_MODL_intersect_objects(Curve1, Curve2, dTol, &iIntersections, &Intersections));
	if(iIntersections != 1)
		return false;
	else if(Intersections[0]->intersect_type == UF_MODL_INTERSECT_POINT)
		return false;
	else
		return true;
}
bool CurvesCoincide(tag_t Curve1, tag_t Curve2, double dTol)
{
UF_EVAL_p_t Eval1, Eval2;
double dPoint1[3], dPoint2[3], dPar1[2]={0,1}, dPar2[2]={0,1};
bool bRes1=true, bRes2=true;

	if(Curve1==NULL_TAG || Curve2==NULL_TAG)
		return false;

	if(dTol == 0)
		dTol = dG_DistTol;

	UF_CALL(UF_EVAL_initialize(Curve1, &Eval1));
	UF_CALL(UF_EVAL_initialize(Curve2, &Eval2));

	UF_CALL(UF_EVAL_ask_limits(Eval1, dPar1));
	UF_CALL(UF_EVAL_ask_limits(Eval2, dPar2));

	for(int i=0;i<100;i++)
	{
		UF_CALL(UF_EVAL_evaluate(Eval1, 0, dPar1[0] + (dPar1[1]-dPar1[0])*(double)i/99.0, dPoint1, NULL));
		UF_CALL(UF_EVAL_evaluate(Eval2, 0, dPar2[0] + (dPar2[1]-dPar2[0])*(double)i/99.0, dPoint2, NULL));
		if(sqrt((dPoint1[0]-dPoint2[0])*(dPoint1[0]-dPoint2[0]) + (dPoint1[1]-dPoint2[1])*(dPoint1[1]-dPoint2[1]) + (dPoint1[2]-dPoint2[2])*(dPoint1[2]-dPoint2[2])) > dTol)
		{
			bRes1 = false;
			break;
		}
	}
	for(int i=0;i<100;i++)
	{
		UF_CALL(UF_EVAL_evaluate(Eval1, 0, dPar1[0] + (dPar1[1]-dPar1[0])*(double)i/99.0, dPoint1, NULL));
		UF_CALL(UF_EVAL_evaluate(Eval2, 0, dPar2[1] - (dPar2[1]-dPar2[0])*(double)i/99.0, dPoint2, NULL));
		if(sqrt((dPoint1[0]-dPoint2[0])*(dPoint1[0]-dPoint2[0]) + (dPoint1[1]-dPoint2[1])*(dPoint1[1]-dPoint2[1]) + (dPoint1[2]-dPoint2[2])*(dPoint1[2]-dPoint2[2])) > dTol)
		{
			bRes2 = false;
			break;
		}
	}

	UF_CALL(UF_EVAL_free(Eval1));
	UF_CALL(UF_EVAL_free(Eval2));

	return bRes1 || bRes2;
}

//   X,   A  B
//   B
/*CPoint3D FindX(CPoint3D A, CPoint3D B)
{
double xa=A.X, ya=A.Y, za=A.Z;
double xb=B.X, yb=B.Y, zb=B.Z;
double d;

	d = xb*xb*xb*xb*za*za + xb*xb*xb*xb*ya*ya + yb*yb*yb*yb*xa*xa + yb*yb*xb*xb*ya*ya + zb*zb*zb*zb*ya*ya + 2*xb*xb*ya*ya*zb*zb + xb*xb*xa*xa*yb*yb - 2*yb*yb*yb*xa*xb*ya - 2*zb*zb*ya*yb*xa*xb + za*za*yb*yb*zb*zb - 2*xb*xb*xb*xa*yb*ya + 2*zb*zb*yb*yb*xa*xa - 2*zb*zb*zb*ya*yb*za + zb*zb*zb*zb*xa*xa - 2*zb*zb*zb*xa*xb*za + zb*zb*xb*xb*za*za + za*za*yb*yb*yb*yb + ya*ya*zb*zb*yb*yb - 2*yb*yb*yb*ya*zb*za - 2*xb*xb*ya*zb*yb*za - 2*yb*yb*za*xa*zb*xb + 2*za*za*yb*yb*xb*xb + xa*xa*zb*zb*xb*xb + 2*xb*xb*xb*xa*zb*za;
}*/

// " "  
//  Thicken Sheet    -dLayer  dLayer
//     Body
void PeelBody(tag_t Body, double dLayer, bool bTrans)
{
uf_list_p_t BodyFaces, ListDisjoint;
int iBodyFaces;
tag_t SewFace, *SewTools, Temp, SheetBody;
char *cOffset1, *cOffset2;
CString string1, string2;

	UF_CALL(UF_MODL_ask_body_faces(Body, &BodyFaces));
	UF_CALL(UF_MODL_ask_list_count(BodyFaces, &iBodyFaces));

	SewTools = new tag_t[iBodyFaces-1];

	//     
	UF_CALL(UF_MODL_ask_list_item(BodyFaces, 0, &SewFace));;
	UF_CALL(UF_MODL_extract_face(SewFace, 0, &Temp));
	SewFace = Temp;
	for(int i=1;i<iBodyFaces;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(BodyFaces, i, &SewTools[i-1]));;
		UF_CALL(UF_MODL_extract_face(SewTools[i-1], 0, &Temp));
		SewTools[i-1] = Temp;
	}

	//   
	{
		int iL;
		UF_CALL(UF_LAYER_ask_work_layer(&iL));
		UF_CALL(UF_LAYER_set_status(111, UF_LAYER_WORK_LAYER));
		UF_CALL(UF_MODL_create_sew(0, 1, &SewFace, iBodyFaces-1, SewTools, .1, 0, &ListDisjoint, &SheetBody));
		UF_CALL(UF_LAYER_set_status(iL, UF_LAYER_WORK_LAYER));
		UF_CALL(UF_LAYER_set_status(111, UF_LAYER_INACTIVE_LAYER));
	}
	{
		tag_t Temp;
		UF_CALL(UF_MODL_ask_feat_body(SheetBody, &Temp));
		SheetBody = Temp;
	}

	//""  
	UF_CALL(UF_OBJ_set_blank_status(SheetBody, UF_OBJ_BLANKED));
//	if(bTrans)
//		UF_CALL(UF_OBJ_set_translucency(SheetBody, 100));

	//   
	string1.Format("%f", -dLayer);
	cOffset1 = string1.GetBuffer();
	string2.Format("%f", dLayer);
	cOffset2 = string2.GetBuffer();
	UF_CALL(UF_MODL_create_thicken_sheet(SheetBody, cOffset1, cOffset2, UF_NULLSIGN, &Temp));
	UF_CALL(UF_MODL_ask_feat_body(Temp, &SheetBody));

	//    
	UF_CALL(UF_MODL_operations(Body, SheetBody, UF_NEGATIVE));

	// 
	UF_CALL(UF_MODL_delete_list(&BodyFaces));
	delete [] SewTools;
}

//,  dVector3,   dVector1  dVector2
void FindThirdVector(double *dVector1, double *dVector2, double *dVector3)
{
double dL;

	dVector3[0] = dVector1[1]*dVector2[2] - dVector1[2]*dVector2[1];
	dVector3[1] = dVector2[0]*dVector1[2] - dVector1[0]*dVector2[2];
	dVector3[2] = dVector1[0]*dVector2[1] - dVector2[0]*dVector1[1];
}

//,      Body,   ReservedEdges  dRadius
//    
double RoundAllEdges(tag_t Body, tag_t *ReservedEdges, int iNumOfReservedEdges, double dRadius)
{
tag_t Edge;
uf_list_p_t BodyEdges;
int iBodyEdges;
logical Smoothness;
UF_MODL_edge_blend_data_s BlendData;
UF_MODL_blend_edge_s *BlendEdge;
CString string;

	//  
	BlendData.blend_type = 0;
	BlendData.blend_instanced = FALSE;
	BlendData.blend_setback = FALSE;
	BlendData.vrb_tolerance = .1;
	string.Format("%f", dRadius);
	memcpy(BlendData.blend_radius, string.GetBuffer(), string.GetLength());
	BlendData.blend_radius[string.GetLength()] = '\0';
	BlendData.smooth_overflow = TRUE;
	BlendData.cliff_overflow = TRUE;
	BlendData.notch_overflow = TRUE;
	BlendData.number_edges = 0;

	UF_CALL(UF_MODL_ask_body_edges(Body, &BodyEdges));
	UF_CALL(UF_MODL_ask_list_count(BodyEdges, &iBodyEdges));

	//   
	for(int i=0;i<iBodyEdges;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(BodyEdges, i, &Edge));
		UF_CALL(UF_MODL_ask_edge_smoothness(Edge, 5, &Smoothness));
		if(Smoothness == FALSE)
		{
			bool bReserved = false;
			//,       
			for(int j=0;j<iNumOfReservedEdges;j++)
				if(Edge == ReservedEdges[j])
				{
					bReserved = true;
					break;
				}
			// 
			if(!bReserved)
				BlendData.number_edges++;
		}
	}

	//   
	BlendEdge = new UF_MODL_blend_edge_s[BlendData.number_edges];

	//   
	BlendData.number_edges = 0;
	for(int i=0;i<iBodyEdges;i++)
	{
		UF_CALL(UF_MODL_ask_list_item(BodyEdges, i, &Edge));
		UF_CALL(UF_MODL_ask_edge_smoothness(Edge, 5, &Smoothness));
		if(Smoothness == FALSE)
		{
			bool bReserved = false;
			//,       
			for(int j=0;j<iNumOfReservedEdges;j++)
				if(Edge == ReservedEdges[j])
				{
					bReserved = true;
					break;
				}
			// 
			if(!bReserved)
			{
				BlendEdge[BlendData.number_edges].edge = Edge;
				BlendEdge[BlendData.number_edges].number_points = 0;
//				UF_CALL(UF_MODL_create_curve_from_edge(Edge, &Edge));
//				UF_CALL(UF_OBJ_set_color(Edge, UF_OBJ_RED));
				BlendData.number_edges++;
			}
		}
	}

	//  
	uf_list_p_t Feature;
	UF_CALL(UF_MODL_create_list(&Feature));

	BlendData.edge_data = BlendEdge;
	Edge = NULL_TAG;
	if(BlendData.number_edges)
		while(UF_MODL_create_edge_blend(&BlendData, &Edge) && dRadius>1)
		{
			UF_CALL(UF_MODL_put_list_item(Feature, Edge));

			dRadius--;
			string.Format("%f", dRadius);
			memcpy(BlendData.blend_radius, string.GetBuffer(), string.GetLength());
			BlendData.blend_radius[string.GetLength()] = '\0';
		}

	//  ( ) 
//	UF_CALL(UF_MODL_suppress_feature(Feature));
//	UF_CALL(UF_MODL_delete_feature(Feature));

	// 
	delete [] BlendEdge;
	UF_CALL(UF_MODL_delete_list(&BodyEdges));

	return dRadius;
}

//,     
double CalcDist(double *dPoint1, double *dPoint2)
{
	return sqrt((dPoint1[0]-dPoint2[0])*(dPoint1[0]-dPoint2[0]) + (dPoint1[1]-dPoint2[1])*(dPoint1[1]-dPoint2[1]) + (dPoint1[2]-dPoint2[2])*(dPoint1[2]-dPoint2[2]));
}

//      Curve    Edges
//        100   
tag_t FindClosestEdge(tag_t Curve, uf_list_p_t *Edges)
{
tag_t Edge;
UF_EVAL_p_t Eval;
int iEdges, iMinDist;
double dDist, dCurDist, dMinDist=1e100, dPar[2], dPoint[3];

	if(Curve==NULL_TAG)
		return NULL_TAG;

	UF_CALL(UF_EVAL_initialize(Curve, &Eval));

	UF_CALL(UF_EVAL_ask_limits(Eval, dPar));

	UF_CALL(UF_MODL_ask_list_count(*Edges, &iEdges));
	for(int i=0;i<iEdges;i++)
	{
		dCurDist = 0;
		UF_CALL(UF_MODL_ask_list_item(*Edges, i, &Edge));
		for(int j=0;j<100;j++)
		{
			UF_CALL(UF_EVAL_evaluate(Eval, 0, dPar[0] + (dPar[1]-dPar[0])*(double)j/99.0, dPoint, NULL));
			UF_CALL(UF_MODL_ask_minimum_dist(Edge, NULL_TAG, 0, dPoint, 1, dPoint, &dDist, dPoint, dPoint));
			dCurDist += dDist;
		}
		if(dCurDist<dMinDist)
		{
			iMinDist = i;
			dMinDist = dCurDist;
		}
	}

	UF_CALL(UF_EVAL_free(Eval));

	UF_CALL(UF_MODL_ask_list_item(*Edges, iMinDist, &Edge));
	return Edge;
}