//     
//  ,     
// :
//1 -      , ,  
//2 -        , ,    
int FindSignificantFaces(
	tag_t SheetBody,
	tag_t *FaceBase,
	uf_list_p_t *FacesRounding,
	uf_list_p_t *FacesBevel,
	uf_list_p_t *FacesUndercutRounding,
	uf_list_p_t *FacesUndercut,
	uf_list_p_t *FacesPunchRounding,
	uf_list_p_t *FacesPunchBevel,
	uf_list_p_t *FacesPressInRounding1,
	uf_list_p_t *FacesPressInBevel,
	uf_list_p_t *FacesPressInRounding2,
	uf_list_p_t *FacesPressInBottom);


//     -  
// :           .
//1 -     
int FindBaseFaces(tag_t SheetBody, tag_t *Base);

//,   ,    
// :
//1 -    
int GetOuterEdges(tag_t Face, uf_list_p_t *Edges);

//, y  
// ,   ,      
// :
//1 -       , ,  
int FindOuterInnerFaces(tag_t Face, uf_list_p_t *OuterAdjFaces, uf_list_p_t *InnerAdjFaces);

//      
int ScanSectionParms(
	tag_t Plane,			// 
	uf_list_p_t FacesBevel,	// "" 
	double dPoint[3],		// 
	double *dSectionPoint,	//  
	double *dRadius=NULL,	//  
	double *dDistance=NULL);//  

//     ,    
double CalcR(CPoint3D P1, CPoint3D P2, CPoint3D P3, bool *bNoCircle);

//,    
double CalcAngle(CPoint3D V1, CPoint3D V2);

//  
double Gamma
(
	double K,
	double n,
	double t,
	double h,
	double R,
	double r,
	double Alpha,
	double E
);

//  Point   Axis   dAngle
void Rotate(CPoint3D *Point, CPoint3D Axis, double dAngle);
void Rotate(double *dPoint, CPoint3D Axis, double dAngle);

//This function calculates angle between two vectors
//Input values:
//Coordinates of the two vectors
double CalcAngle(double *dVector1, double *dVector2);

//This function transforms coordinates of a point to new coordinate system
//Input values:
//Coordinate of the point
//Coordinates of three vectors of new coordinate system
//Offset after transforming
void TransformCoordinateSystem(CPoint3D *Point, double *dX, double *dY, double *dZ, double *dOffset);

//This function creates a point distant from a given point to given distance in given direction
//Input values:
//Cooordinates of the origin point
//Coordinates of calculated point
//Direction vector
//Distance
void OffsetPoint(double *dOrigin, double *dPoint, double *dVector, double dDistance);

//  /       
// ,   
void ConnectCurves(tag_t Curve1, tag_t Curve2);

//,    ( )  
//   dTol ( dTol==0,  dG_DistTol)
bool CurvesCoincide2(tag_t Curve1, tag_t Curve2, double dTol=0);
bool CurvesCoincide(tag_t Curve1, tag_t Curve2, double dTol=0);

//   X,   A  B
//   B
CPoint3D FindX(CPoint3D A, CPoint3D B);

// " "  
//  Thicken Sheet    -dLayer  dLayer
//     Body
void PeelBody(tag_t Body, double dLayer, bool bTrans=true);

//,  dVector3,   dVector1  dVector2
void FindThirdVector(double *dVector1, double *dVector2, double *dVector3);

//,      Body,   ReservedEdges  dRadius
//    
double RoundAllEdges(tag_t Body, tag_t *ReservedEdges, int iNumOfReservedEdges, double dRadius);

//,     
double CalcDist(double *dPoint1, double *dPoint2);

//      Curve    Edges
//        100   
tag_t FindClosestEdge(tag_t Curve, uf_list_p_t *Edges);
